# when.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  W   W H   H EEEEE N   N
#  W   W H   H E     NN  N
#  W W W HHHHH EEEE  N N N
#  W W W H   H E     N  NN
#   W W  H   H EEEEE N   N
#
=begin ###########################################################
#=Date::Extended                                                 #
\===@t̓tƎ                                         #
$===The class which represents date and time with calendar       #
#                                                                #
\==X[p[NX:                                               #
$==Super Class:                                                  #
#*Date*                                                          #
=end #############################################################

require 'rational' unless Object.const_defined?('Rational')
require 'when/func'
require 'when/calendar'

class Date

=begin #########################################################
\==Date NX ǉ NX \bh:                           #
$==Additional Class Method of Date Class:                      #
=end ###########################################################
  class << self

=begin ***********
#--- Date.utc([cal=Civil.new,] y [, m [, d [, h [, min [, s [, us]]]]]])
\  UTCŎw肳ꂽ Date+IuWFNg𐶐܂B
\  ts̏ꍇ  ArgumentError 𔭐܂B
\  ȉȂꍇ́An߂ɑΉ Date+IuWFNg𐶐܂B
\  ȉȂꍇ́A^p̔NɑΉ Date+IuWFNg𐶐
\  (͗@ɂẮA11ȊOɂȂ܂)B
\
\    cal  Calendar+IuWFNg܂͂w肷镶
\    y    N
\    m    
\    d    
\    h    
\    min  
\    s    b
\    us   b̏(under second)
=end =============
    def utc(*date)
      unless (a = Calendar.select(date))
        raise ArgumentError, 'invalid date'
      end
      a[2] -= Timezone.zone.zone if date.length == 0
      Extended.new_date(a[0], a[2], Timezone.new(0))
    end

=begin ***********
#--- Date.autozone([cal=Civil.new,] y [, m [, d [, h [, min [, s [, us]]]]]])
\  w̗@ internal_timezoneŎw肳ꂽ Date+IuWFNg
\  𐶐܂Bw̗@^C][ɈˑȂꍇ́A[J̃^C
\  ][p܂B
\  ts̏ꍇ  ArgumentError 𔭐܂B
\  ȉȂꍇ́An߂ɑΉ Date+IuWFNg𐶐܂B
\  ȉȂꍇ́A^p̔NɑΉ Date+IuWFNg𐶐
\  (͗@ɂẮA11ȊOɂȂ܂)B
\
\    cal  Calendar+IuWFNg܂͂w肷镶
\    y    N
\    m    
\    d    
\    h    
\    min  
\    s    b
\    us   b̏(under second)
=end =============
    def autozone(*date)
      unless (a = Calendar.select(date))
        raise ArgumentError, 'invalid date'
      end
      zone = Timezone.new(a[0].internal_timezone)
      if date.length == 0
        a[2] -= Timezone.zone.zone
      else
        a[2]  = zone.sd_to_jd(a[2])
      end
      Extended.new_date(a[0], a[2], zone)
    end

=begin ***********
#--- Date.local([cal=Civil.new,] y [, m [, d [, h [, min [, s [, us]]]]]])
\  [J^CŎw肳ꂽ Date+IuWFNg𐶐܂B
\  ts̏ꍇ ArgumentError 𔭐܂B
\  ȉȂꍇ́An߂ɑΉ Date+IuWFNg𐶐܂B
\  ȉȂꍇ́A^p̔NɑΉ Date+IuWFNg𐶐
\  (͗@ɂẮA11ȊOɂȂ܂)B
\
\    cal  Calendar+IuWFNg܂͂w肷镶
\    y    N
\    m    
\    d    
\    h    
\    min  
\    s    b
\    us   b̏(under second)
=end =============
    def local(*date)
      unless (a = Calendar.select(date))
        raise ArgumentError, 'invalid date'
      end
      zone = Timezone.zone
      Extended.new_date(a[0], zone.sd_to_jd(a[2]), zone)
    end

=begin ***********
#--- Date.when?([cal=Civil.new,] y [, m [, d [, h [, min [, s [, us]]]]]])
\  [J^CŎw肳ꂽDate+IuWFNg𐶐܂B
\  ts̏ꍇ nil Ԃ܂B

\  ȉȂꍇ́An߂ɑΉ Date+IuWFNg𐶐܂B
\  ȉȂꍇ́A^p̔NɑΉ Date+IuWFNg𐶐
\  (͗@ɂẮA11ȊOɂȂ܂)B
\  NȉȂꍇ́AݓɑΉ Date+IuWFNg𐶐܂B
\    cal  Calendar+IuWFNg܂͂w肷镶
\    y    N
\    m    
\    d    
\    h    
\    min  
\    s    b
\    us   b̏(under second)
=end =============
    def when?(*date)
      return nil unless a = Calendar.select(date)
      zone = Timezone.zone
      Extended.new_date(a[0], zone.sd_to_jd(a[2]), zone)
    end
  end # of Date class methods

=begin #########################################################
\==Date NX ǉ pubN CX^X \bh:          #
$==Additional Public Instance Method of Date Class:            #
=end ###########################################################
  public

  unless Object.const_defined?('DateTime') # beginning of old date compatibility
  
=begin ***********
#--- Date#to_extended
\  Date*IuWFNgDate::Extended+IuWFNgɕϊĕԂ܂B
\
=end =============
    def to_extended() Extended.new(Civil.new(sg), jd, Timezone.new(0)) end

=begin ***********
#--- Date#strftime([fmt='%FT%T%f%Z'])
\  w肵ɏ]āA𕶎ɕϊĕԂ܂B
\  %[\bh]  %[] Ƃg܂B
\
\    fmt  
=end =============
    def strftime(fmt='%FT%T%f%Z') to_extended.strftime(fmt) end
    def asctime() strftime('%c') end
    alias_method :ctime, :asctime

=begin ***********
#--- Date#zone
\  ^C][ItZbgԂ܂B
=end =============
    def zone()  'Z'  end

=begin ***********
#--- Date#rjd
\  EXʓ(-4712-01-01T12:00:00Žoߎ(P ))Ԃ܂B
\  ʌ݊ێ̂߁Ajd  sdn ̈ӖɎĝŁAdate2.rb ɂ킹
\  rjd(Real/Rational Julian Day)ƖĂ܂BڂDate#sdn 
\  B
=end =============
    alias_method :rjd, :jd

=begin ***********
#--- Date#jdn
\  rjd ̏_ȉľܓ( Julian Day Number ܂ Julian Day
\  Noon ̂)Ԃ܂B
=end =============
    alias_method :jdn, :jd

=begin ***********
#--- Date#sd
\  nʓ(n-4712-01-01T12:00:00̌oߎ(P ))Ԃ܂B
=end =============
    alias_method :sd, :jd

  else # end of old date compatibility and beginning of newdate compatibility
=begin ***********
|--- Date#to_extended
|  Date*IuWFNgDate::Extended+IuWFNgɕϊĕԂ܂B
|
=end =============
    def to_extended() Extended.new(Civil.new(sg), rjd, Timezone.new(of)) end

=begin ***********
|--- Date#strftime([fmt='%FT%T%f%Z'])
|  w肵ɏ]āA𕶎ɕϊĕԂ܂B
|
|    fmt  
=end =============
    alias_method :strftime!, :strftime
    def strftime(fmt='%FT%T%f%Z')
      return to_extended.strftime(fmt) if fmt =~ /^%f|^%\[|[^%]%f|[^%]%\[/
      strftime!(fmt)
    end

=begin ***********
|--- Date#jdn
|  rjd ̏_ȉľܓ( Julian Day Number ܂ Julian Day
|  Noon ̂)Ԃ܂B
=end =============
    def jdn() (rjd + 1.to_r/2).floor end

=begin ***********
|--- Date#sd
|  nʓԂ܂B
=end =============
    def sd() (rjd + of) end

  end # of newdate compatibility

=begin ***********
#--- Date#sdn
#--- Date#jd
\  nߒʓ(*)Ԃ܂B
\  * sd ̏_ȉۂ߂
\
\  1̎n܂̎@ɂĈقȂ邽߁Aۂ߂͕Kľܓ
\  ͂܂B{\bh͕K߂ɑΉ sdn (Serial Day Number
\  ܂ Serial Day Noon ̂ - ̓EXʓƂ̊֌WȂ
\  \̂ŁuńvƂ܂݂ALocal Day Number 
\  ͂Ȃ)Ԃ܂B
\  ŏDateNX͎TOȂ̂ŁAtɑΉ郆EX
\  ʓ()\bhjdŕԂ܂B͔ɑÓU镑
\  łAȊȎI͂Ȃ̂łB񉺈ʌ݊
\  ̕ێ̂߁Au΁vn-Ƃĕ jd ܂-ƒnvn
\  -Ƃĕ sd ܂-Ƃ̗OƂ܂B
\
=end =============
  alias_method :sdn, :jd

=begin ***********
#--- Date#jdf
\  rjd - jdn Ԃ܂BłƂ͌܂B
=end =============
  def jdf()  rjd - jdn end

=begin ***********
#--- Date#sdf
\  sd - sdn Ԃ܂BłƂ͌܂B
=end =============
  def sdf()  sd - sdn end

=begin ***********
#--- Date#day_fraction
\  sdf + 1/2 Ԃ܂B
=end =============
  def day_fraction()  sdf + 1.to_r / 2 end

=begin ***********
#--- Date#cal
\  self gp Calendar+IuWFNgԂ܂B
=end =============
  def cal() to_extended.cal end

=begin ***********
#--- Date#timezone
\  self gp Timezone+IuWFNgԂ܂B
=end =============
  def timezone() to_extended.timezone end

=begin ***********
#--- Date#new_calendar(cal)
#--- Date#%(cal)
\  self 𕡐āAgp Calendar+IuWFNgݒ肵܂B
\
\    cal  Calendar+IuWFNg܂͂w肷镶
=end =============
  def new_calendar(cal)
    return new_start(cal) unless Calendar === cal || String === cal 
    to_extended.new_calendar(cal)
  end

=begin ***********
#--- Date#new_zone(zone)
#--- Date#|(zone)
\  self 𕡐āAgp鎞ݒ肵܂B
\
\    zone Timezone+IuWFNg܂͂w肷鐔lor
=end =============
  def new_zone(zone) to_extended.new_zone(zone) end

=begin ***********
#--- Date#new_period(period)
#--- Date#/(period)
\  self [_ƂA period  Period+IuWFNg𐶐܂B
\  I_͊ԂɊ܂܂܂B
\  (Period+IuWFNg쐬̂߁ARange*IuWFNg
\   Ԃ܂)
\
\    period Ԃ ISO8601ԕ
=end =============
  def new_period(period)
    period =~ /([\/]*)$/
    if ($1.length % 2) == 0 then  self...(self+period)
    else                          (self+period)...self
    end
  end

=begin ***********
#--- Date#show_all_date([k=true [, n=true]])
\  Nb̏܂łׂ̂Ă̗vfԂ܂B
\
\    k  L k Ԗڂ̓t\ɑΉlԂ悤w܂B
\       true Ȃ΁AׂĂ̗Lȓt\zŕԂ܂B
\    n  true ȂNb̏܂łׂĂ̗vfԂ܂B
\       lȂ΁AΉvf݂̂Ԃ܂B
=end =============
  def show_all_date(k=true, n=true)
    to_extended.show_all_date(k,n)
  end
  def hour(k=1)   show_all_date(k, 3) end
  def minute(k=1) show_all_date(k, 4) end
  def second(k=1) show_all_date(k, 5) end
  def usec(k=1)   show_all_date(k, 6) end

=begin ***********
#--- Date#+(n)
\  self  n  Date*IuWFNgԂ܂B
\
\    n  l(Numeric*)̏ꍇAn  Date*IuWFNgԂ܂B
\       ](Residue+)̏ꍇA܂͈ȍ~̓tōŏɏ𖞂
\       Date*IuWFNgԂ܂B
\       (String*)̏ꍇAΉ]܂ISO8601ԕ
\       āA̎wɏ]܂B
=end =============
  alias_method :plus, :+
  def + (x)
    return plus(x) if Numeric === x
    to_extended + x
  end

=begin ***********
#--- Date#-(x)
\  x  Date*IuWFNgȂAself  x Ƃ̊Ԃ̓Ԃ܂B
\  ̑̃IuWFNgȂ x O Date*IuWFNgԂ܂B
\
\    x  t(Date*)̏ꍇAself  x Ƃ̊Ԃ̓Ԃ܂B
\       l(Numeric*)̏ꍇAx O Date*IuWFNgԂ܂B
\       ](Residue+)̏ꍇAȑO̓tōŌɏ𖞂 Date* 
\       IuWFNgԂ܂B
\       (String*)̏ꍇAΉ]܂ISO8601ԕ
\       āA̎wɏ]ċ߂ Date*IuWFNgԂ܂B
=end =============
  alias_method :minus , :-
  def - (x)
    return minus(x) if Numeric === x
    to_extended - x
  end

=begin ***********
#--- Date#<=>(other)
\  ҂rāA-1, 0, 1Ԃ܂B
\
\    other  rΏۂ Numeric*, Date*IuWFNg
=end =============
  def <=> (other)
    case other
    when Numeric; return rjd <=> other
    when Date;    return rjd <=> other.rjd
    end
    raise TypeError, 'expected numeric or date'
  end

=begin ***********
#--- Date#===(other)
\  ҂̃EXʓ(rjd)rāAvĂΐ^Ԃ܂B
\
\    other  rΏۂ Numeric*, Date*IuWFNg
=end =============
  def === (other)
    case other
    when Numeric; return rjd == other
    when Date;    return rjd == other.rjd
    end
    raise TypeError, 'expected numeric or date'
  end

=begin ***********
#--- Date#step(limit, step) {|date| ... }
\  self  limit ܂ step ݂ŃubNs܂B
\
\    limit  I_Date*IuWFNg
\    step   ݂w肷Numeric*IuWFNg܂ISO8601ԕ
=end =============
  alias_method :step!, :step
  def step(limit, step)
    return step!(limit, step) unless String === step
    unless step =~ /^\/*P?\d*Y?\d*M?\d*W?\d*D?(T\d*H?\d*M?\d*S?)?\/*$/
      raise ArgumentError, 'invalid step format'
    end
    step =~ /(\/*)$/
    op = ($1.length % 2) == 0 ? :<= : :>=
    da = self
    while da.__send__(op, limit)
      yield da
      da += step
    end
    self
  end

=begin ***********
#--- Date#[](key)
\  key Ŏw肵Ԃ܂B
\
\    key    
=end =============
  def [](key)
    to_extended[key]
  end

=begin #########################################################
|==Date::Extend NX ݊ pubN CX^X \bh:  #
|==Conpatible Public Instance Method of Date::Extend Class:    #
=end ###########################################################
  class Extended < Date
    public

=begin ***********
|--- Extended#to_extended
|  Date*IuWFNgDate::Extended+IuWFNgɕϊĕԂ܂B
|
=end =============
    def to_extended() dup end

=begin ***********
|--- Extended#sd
|  nʓԂ܂B
=end =============
    def sd() @zone.jd_to_sd(@rjd) end

=begin ***********
|--- Extended#sdn
|--- Extended#jd
|  nߒʓ(*)Ԃ܂B
|  * sd ̏_ȉۂ߂
|
|  1̎n܂̎@ɂĈقȂ邽߁Aۂ߂͕Kľܓ
|  ͂܂B{\bh͕K߂ɑΉ sdn (Serial Day Number
|  ܂ Serial Day Noon ̂ - ̓EXʓƂ̊֌WȂ
|  \̂ŁALocal Day Number Ƃ͂Ȃ)Ԃ܂B
=end =============
    def sdn() @cal.round_day(sd) end
    alias_method :jd, :sdn

=begin ***********
|--- Extended#rjd
|  EXʓ(-4712-01-01T12:00:00Žoߎ(P ))Ԃ܂B
=end =============
    def rjd() @rjd end

=begin ***********
|--- Extended#jdn
|  rjd ̏_ȉľܓ( Julian Day Number ܂ Julian Day
|  Noon ̂)Ԃ܂B
=end =============
    def jdn() (rjd+1.to_r/2).floor end

=begin ***********
|--- Extended#cal
|  self gpĂ Calendar+IuWFNgԂ܂B
=end =============
    def cal() @cal end

=begin ***********
|--- Extended#timezone
|  self gpĂ Timezone+IuWFNgԂ܂B
=end =============
    def timezone() @zone end

=begin ***********
|--- Extended#zone
|  ^C][ItZbgԂ܂B
=end =============
    def zone() @zone.to_s_with_dst(rjd) end

=begin ***********
|--- Extended#new_calendar(cal)
|--- Extendd#%(cal)
|  self 𕡐āAgp Calendar+IuWFNgݒ肵܂B
|
|    cal  Calendar+IuWFNg܂͂w肷镶
=end =============
    def new_calendar(cal)
      case cal
      when Calendar;  new_cal = cal
      when Numeric;   new_cal = Civil.new(cal.to_i)
      when String
        unless (new_cal = Calendar.get(cal))
          raise ArgumentError, 'invalid calendar name'
        end
      else; raise TypeError, 'invalid calendar type'
      end
      type.new_date(new_cal, @rjd, @zone)
    end

=begin ***********
|--- Extended#new_zone(zone)
|--- Extended#|(zone)
|  self 𕡐āAgp鎞ݒ肵܂B
|
|    zone Timezone+IuWFNg܂͂w肷鐔lor
=end =============
    def new_zone(zone)
      case zone
      when Timezone; new_zone = zone
      when Numeric;  new_zone = Timezone.new(zone)
      when String
        unless (new_zone = Timezone.get(zone))
          raise ArgumentError, 'invalid timezone name'
        end
      else; raise TypeError, 'invalid timezone type'
      end
      type.new_date(@cal, @rjd, new_zone)
    end

=begin ***********
|--- Extended#show_all_date([k=true [, n=true]])
|  Nb̏܂łׂ̂Ă̗vfԂ܂B
|
|    k  L k Ԗڂ̓t\ɑΉlԂ悤w܂B
|       true Ȃ΁AׂĂ̗Lȓt\zŕԂ܂B
|    n  true ȂNb̏܂łׂĂ̗vfԂ܂B
|       lȂ΁AΉvf݂̂Ԃ܂B
=end =============
    def show_all_date(k=true, n=true)
      a = @cal.sd_to_date(sd, k)
      return a unless Numeric === n && (0..6) === n
      case k
      when false; return  a
      when true;  return (a.collect {|s| s[n]})
      else;       return  a[n]
      end
    end

=begin ***********
|--- Extended#+(n)
|  self  n  Date*IuWFNgԂ܂B
|
|    n  l(Numeric*)̏ꍇAn  Date*IuWFNgԂ܂B
|       ](Residue+)̏ꍇA܂͈ȍ~̓tōŏɏ𖞂
|       Date*IuWFNgԂ܂B
|       (String*)̏ꍇAΉ]܂ISO8601ԕ
|       āA̎wɏ]܂B
=end =============
    def + (x)
      case x
      when Numeric
        type.new_date(@cal,@zone.sd_to_jd(x+sd),@zone)
      when Residue
        x + self
      when String
        if (r = Residue.get(x))
          r + self
        else
          type.new_date(@cal,@zone.sd_to_jd(@cal.shift_sd(sd,x)),@zone)
        end
      else
        raise ArgumentError, 'invalid offset'
      end
    end

=begin ***********
|--- Extended#-(x)
|  x  Date*IuWFNgȂAself  x Ƃ̊Ԃ̓Ԃ܂B
|  ̑̃IuWFNgȂ x O Date*IuWFNgԂ܂B
|
|    x  t(Date*)̏ꍇAself  x Ƃ̊Ԃ̓Ԃ܂B
|       l(Numeric*)̏ꍇAx O Date*IuWFNgԂ܂B
|       ](Residue+)̏ꍇAȑO̓tōŌɏ𖞂 Date* 
|       IuWFNgԂ܂B
|       (String*)̏ꍇAΉ]܂ISO8601ԕ
|       āA̎wɏ]ċ߂ Date*IuWFNgԂ܂B
=end =============
    def - (x)
      case x
      when Numeric
        return type.new_date(@cal,@zone.sd_to_jd(-x+sd),@zone)
      when Residue
        -x + self
      when Date;    return rjd - x.rjd
      when String
        if (r = Residue.get(x))
          -r + self
        else
          return type.new_date(@cal,@zone.sd_to_jd(@cal.shift_sd(sd,x+'/')),@zone)
        end
      else
        raise ArgumentError, 'invalid offset'
      end
    end

=begin ***********
|--- Extended#[](key)
|  key Ŏw肵Ԃ܂B
|
|    key    
=end =============
    def [](key)
      q   = @@q
      key =~ /^(.*?)([|](.+))?$/
      body, format = $1, $3
      body.split('.').each do |k|
        case q[k]
        when Hash;  q = q[k]
        when Array; r = q[k][0].call(self)
        when Proc;  r = q[k].call(self)
        when nil;   r = eval('self.'+ k) # add receiver to reject private method
        else raise ArgumentError, 'invalid calendar element'
        end
        return (format ? (format % r) : r) if r
      end
      q.keys.collect do |k|
        self[key+'.'+k]
      end
    end

=begin #########################################################
\==Date::Extended NX ϐ:                                 #
$==Class Variable Date::Extended Class:                        #
=end ###########################################################

=begin ***********
\*@@q pnbV
=end =============
    @@q = {}

=begin #########################################################
\==Date::Extended NX \bh:                             #
$==Class Method of Date::Extended Class:                       #
=end ###########################################################
    class << self
      alias_method :new, :new0

=begin ***********
#--- Extended.calendar_element(key, proc)
\  ̒`o^܂B
\
\    key    
\    proc   ̒l̋ߕ
=end =============
      def calendar_element(key, proc)
        @@q[key] = proc
      end

=begin ***********
#--- Extended._load(str)
\  Marshal*  Extended+IuWFNg̓ǂݍ݂ɗp܂B
\  (,Calendar  singleton ̏ꍇ̑Ήv)
\
\    str  Marshal* ꂽ
=end =============
      def _load(str) new(*Marshal.load(str)) end

=begin ***********
#--- Extended.new_date(cal, rjd, zone)
\  w肳ꂽEXʓDate*/Date::Extended+IuWFNg𐶐܂B
\  ]OYt Date NX̃IuWFNĝ́Acal  Civil, 
\  rjd, zone  0 ̏ꍇłBVo[W Date NX̃IuWFN
\  ĝ cal  Civil, zone Œ̏ꍇłB
\
\    cal   Calendar+IuWFNg
\    rjd   EXʓ
\    zone  Timezone+IuWFNg
=end =============
      if Object.const_defined?('DateTime')
        def new_date(cal, rjd, zone)
          unless cal.type == Civil && zone.type == Timezone
            return new(cal, rjd, zone) 
          end
          h = cal.to_hash.dup
          b = Civil.new.to_hash
          b['Title']             = h['Title']  = nil
          b['Reform_JD']         = h['Reform_JD'] 
          b['TimeUnits'][1][0]   = h['TimeUnits'][1][0]
          return new(cal, rjd, zone) unless h == b
          return Date.new0(rjd, zone.zone, cal['Reform_JD'])
        end
      else
        def new_date(cal, rjd, zone)
          unless cal.type == Civil && zone.type == Timezone
            return new(cal, rjd, zone) 
          end
          h = cal.to_hash.dup
          b = Civil.new.to_hash
          b['Title']             = h['Title']  = nil
          b['Reform_JD']         = h['Reform_JD'] 
          b['TimeUnits'][1][0]   = h['TimeUnits'][1][0]
          return new(cal, rjd, zone) unless h == b
          if rjd == rjd.floor && zone.zone == 0  
            return Date.new1(rjd.floor, cal['Reform_JD'])
          end
          return new(cal, rjd, zone)
        end
      end
    end # of Date::Extended class methods

=begin ***********
#--- Extended.new(cal, rjd, zone)
\  w肳ꂽEXʓ Extended+IuWFNg𐶐܂B
\
\    cal   Calendar+IuWFNg
\    rjd   EXʓ
\    zone  Timezone+IuWFNg
\
\*CX^Xϐ
\  @cal  Calendar+IuWFNg
\  @rjd  EXʓ
\  @zone Timezone+IuWFNg
=end =============
    def initialize(cal, rjd, zone)
      @cal, @rjd, @zone = cal, rjd, zone
    end

=begin #########################################################
\==Date::Extended NX pubN CX^X \bh:     #
$==Public Instance Method of Date::Extended Class:             #
=end ###########################################################

=begin ***********
#--- Extended#yday
\  N̒ʎZ(1`N̓)Ԃ܂B
\  ^p\̔NƗ@̔NقȂꍇ́A^p̔NƂ܂B
=end =============
    def yday
       (sdn - @cal.date_to_sd(year)).to_i + 1
    end

=begin ***********
#--- Extended#wday
\  jԂ܂(j:0, ... yj:6)B
\  ^p\̓̋؂肪ߑO0łȂꍇA^p\̓tƂ܂B
\  (ႦΗ[1n܂ꍇAߑO0O1i񂾎jԂ܂)
=end =============
    def wday
       (sdn + 1) % 7
    end

=begin ***********
#--- Extended#cweek([d=4 [, w=1]])
\  TԂ܂(1-53)B
\
\    d  1dŏ̏TɌŒ肵܂B
\    w  w jT̎n߂Ƃ܂(0:j,..,6yj)
=end =============
  def cweek(d=4, w=1) (self % Week.new(d,w)).mon end

=begin ***********
#--- Extended#>>(n)
\  n  Extended+IuWFNgԂ܂B
\
\    n  Numeric*IuWFNg
=end =============
    def >> (n)
      type.new(@cal, timezone.sd_to_jd(@cal.shift_sd_m(sd, n)),  @zone)
    end

=begin ***********
#--- Extended#year ([k=1])
#--- Extended#month ([k=1])
#--- Extended#day ([k=1])
#--- Extended#hour ([k=1])
#--- Extended#minute ([k=1])
#--- Extended#second ([k=1])
#--- Extended#usec ([k=1])

#--- Extended#mon ([k=1])
#--- Extended#mday ([k=1])
#--- Extended#min ([k=1])
#--- Extended#sec ([k=1])
\  ꂼANEEEEEbEb̏, EEEbԂ܂B
\  (uv͌̒ʎZ(1 ܂ 0`̓))
\
\    k  L k Ԗڂ̓t\ɑΉlԂ悤w܂B
\      (@Ƃ Eras+IuWFNggpĂꍇ)
=end =============
    def year(k=1)   show_all_date(k, 0) end
    def month(k=1)  show_all_date(k, 1) end
    def day(k=1)    show_all_date(k, 2) end
    def hour(k=1)   show_all_date(k, 3) end
    def minute(k=1) show_all_date(k, 4) end
    def second(k=1) show_all_date(k, 5) end
    def usec(k=1)   show_all_date(k, 6) end

=begin ***********
#--- Extended#lapse([leap=false]
\  1970-01-01T00:00:00Z ̌oߕbԂ܂B
\  b̏ꍇ́Afalse Ԃ܂B
\  ([b̍l͂܂Ă܂)
\
\    leap  [blƂ true, lȂƂ false
=end =============
    def lapse(leap=false)
      s = (rjd - (Timezone::UTC_EPOCH + 1.to_r/2)) * 86400
      return false if s < 0
      return leap ? s + Timezone.deltaT(rjd) : s
    end

=begin ***********
#--- Extended#to_s([n=1])
\  ɑΉISO8601gԂ܂B
\
\    n   n Ԗڂ̓\\̑gɕϊ邩w
=end =============
    def to_s(n=1)
      a = @cal.sd_to_s(sd, n)
      z = @zone.to_s_with_dst(rjd)
      case a
      when String; a + z
      when Array;  a.collect{|s| s + z }
      else;        a
      end
    end

=begin ***********
#--- Extended#inspect
\  Kernel* W[Œ`Ăgݍ݊֐ p gp܂B
=end =============
    def inspect()
      format('#<%s: %12.5f (%s) %s:%s [%s]>',
              type, rjd.to_f, cal.day_name_abbr(wday), cal.type, cal.name, to_s)
    end

=begin ***********
#--- Extended#strftime([fmt='%FT%T%f%Z'])
\  fmt Ŏw肳ꂽ̏ɏ]āA𕶎ɕϊ܂B
\
\    fmt  ̏
=end =============
  def strftime(fmt='%FT%T%f%Z')
    o = ''
    fmt.gsub(/%%|%\[(.*?)\]/) { |m| m=='%%' ? m : self[$1] }.
    scan(/%[EO]?.|./o) do |c|
      cc = c.sub(/^%[EO]?(.)$/o, '%\\1')
      case cc
      when '%A';o<< cal.day_name(wday)
      when '%a';o<< cal.day_name_abbr(wday)
      when '%B';o<< cal.month_name(mon)
      when '%b';o<< cal.month_name_abbr(mon)                    # P2,ID
      when '%C';o<< cal.elements_to_s(cal.sd_to_date(sd))[0].sub(/-.+?$/,'')
      when '%c';o<< strftime('%a %b %e %H:%M:%S %Y')
      when '%D';o<< strftime('%m/%d/%y')			# P2,ID
      when '%d';o<< cal.elements_to_s(cal.sd_to_date(sd))[2][0..-2]
      when '%e';o<< cal.elements_to_s(cal.sd_to_date(sd))[2][0..-2].sub(/^0/,' ')
      when '%F';o<< strftime('%Y-%m-%d')			# ID
      when '%G';o<< '%.4d' %  cwyear				# ID
      when '%g';o<< '%02d' % (cwyear % 100)			# ID
      when '%H';o<< cal.elements_to_s(cal.sd_to_date(sd))[3][0..-2]
      when '%h';o<< strftime('%b')				# P2,ID
      when '%I';o<< '%02d' % ((hour % 12).nonzero? or 12)
      when '%j';o<< '%03d' % yday
      when '%k';o<< cal.elements_to_s(cal.sd_to_date(sd))[3][0..-2].sub(/^0/,' ')
      when '%l';o<<  '%2d' % ((hour % 12).nonzero? or 12)	# AR,TZ,GL
      when '%M';o<< cal.elements_to_s(cal.sd_to_date(sd))[4][0..-2]
      when '%m';o<< cal.elements_to_s(cal.sd_to_date(sd))[1][0..-2]
      when '%n';o<< "\n"					# P2,ID
      when '%P';o<< if sd < sdn then 'am' else 'pm' end	# GL
      when '%p';o<< if sd < sdn then 'AM' else 'PM' end
      when '%R';o<< strftime('%H:%M')				# ID
      when '%r';o<< strftime('%I:%M:%S %p')			# P2,ID
      when '%S';o<< cal.elements_to_s(cal.sd_to_date(sd))[5]
      when '%f';o<< cal.elements_to_s(cal.sd_to_date(sd))[6]
      when '%s';o<< '%d' % lapse				# TZ,GL
      when '%T';o<< strftime('%H:%M:%S')			# P2,ID
      when '%t';o<< "\t"					# P2,ID
      when '%U';o<< '%02d' % (cweek(1,0) - 1)
      when '%W';o<< '%02d' % (cweek(1,1) - 1)
      when '%u';o<<   '%d' % cwday				# P2,ID
      when '%V';o<< '%02d' % cweek				# P2,ID
      when '%v';o<< strftime('%e-%b-%Y')			# AR,TZ
      when '%w';o<<   '%d' % wday
      when '%X';o<< strftime('%H:%M:%S')
      when '%x';o<< strftime('%m/%d/%y')
      when '%Y';o<< cal.elements_to_s(cal.sd_to_date(sd))[0][ 0..-2]
      when '%y';o<< cal.elements_to_s(cal.sd_to_date(sd))[0][-3..-2]
      when '%Z';o<< zone                  
      when '%z';o<< zone                     			# ID
      when '%%';o<< '%'
      when '%+';o<< strftime('%a %b %e %H:%M:%S %Z %Y')	# TZ
      when '%1';o<< '%d' % sdn
      when '%2';o<< strftime('%Y-%j')
      when '%3';o<< strftime('%Y-%m-%d')
      else;     o<< c
      end
    end
    o
  end

=begin ***********
#--- Extended#_dump(limit)
\  Marshal*  ExtendedIuWFNg̏oɗp܂B
\  (,Calendar  singleton ̏ꍇ̑Ήv)
\
\    limit  ċA𐧌郌x(ۂ͉w肳Ă܂)
=end =============
    def _dump(limit) Marshal.dump([@cal, @rjd, @zone], -1) end

################################################################

    func :rjd, :jdn, :jdf, :day_fraction, :sd, :sdn, :sdf, :jd
    func :lapse #, :show_all_date
    alias_method :%,    :new_calendar
    alias_method :|,    :new_zone
    alias_method :mon,  :month
    alias_method :mday, :day
    alias_method :min,  :minute
    alias_method :sec,  :second
    alias_method :sec_fraction,  :usec
  end

  func :jdn, :jdf, :sd, :sdn, :sdf
  func :show_all_date
  alias_method :%,    :new_calendar
  alias_method :|,    :new_zone
  alias_method :/,    :new_period
  alias_method :min,  :minute
  alias_method :sec,  :second
  alias_method :sec_fraction,  :usec
end
