# ephemeris.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  EEEEE PPPP  H   H EEEEE M     M EEEEE RRRR  I  SSSS
#  E     P   P H   H E     MM   MM E     R   R I S    
#  EEEE  PPPP  HHHHH EEEE  M M M M EEEE  RRRR  I  SSS 
#  E     P     H   H E     M  M  M E     R  R  I     S
#  EEEEE P     H   H EEEEE M     M EEEEE R   R I SSSS 
#
#
=begin #########################################################
#=Ephemeris                                                    #
\===V̈ʒuNX                                       #
#                                                              #
\==X[p[NX:                                             #
$==Super Class:                                                #
#*Outfit+                                                      #
=end ###########################################################

class Ephemeris < Outfit

  @@outfit = {
    'Objs' => [],
    'Hash' => {},
    'Keys' => [
      [['(\\d+[SLMslm])(_(.*))?',
        '(\\d+S=>\\d+L)(_(.*))?',
        '(\\d+L=>\\d+S)(_(.*))?'] , proc{ |m|
          Ephemeris.new('Title'=>m[0], 'Formula'=>m[1], 'Location'=>m[3])
        }
      ],
      ['(([-]?\\d+|[ABVPZ])[RXYZTPNxyztpnah])(_(.*))?', proc{ |m|
          Ephemeris.new('Title'=>m[0], 'Formula'=>m[1], 'Location'=>m[4])
        }
      ]
    ]
  }
  @@outfit['Key0'] = @@outfit['Keys'].dup

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- Ephemeris.get(key [, n=1])
\  L[Agp Ephemeris+IuWFNgIĕԂ܂B
\
\    key  V̈ʒu(Ephemeris+)L[
\    n    n ԖڂɃ}b` Ephemeris+IuWFNgI悤Ɏw
=end =============
    def get(key, n=1)
      case key
      when Ephemeris
        return key if (n -= 1) == 0
      when String
        @@outfit['Objs'].each do |item|
          item._title.each do |title|
            return item if key =~ /^#{title}$/ && (n -= 1) == 0
          end
        end
        @@outfit['Keys'].each do |item|
          [*item[0]].each do |title|
            return item[1].call($~.dup) if key =~ /^#{title}$/ && (n-=1) == 0
          end
        end
      end
      return nil
    end

=begin ***********
#--- Ephemeris.root(y0, t0, &func)
\  tϊ̌vZ܂B
\
\    y0   tϊ֐l(nil Ȃɒl߂)
\    t0   Ɨϐ̏ߎl
\    func tϊ֐
=end =============
    def root(y0, t0, &func)
  
      # ߎl0,1
      # printf("y0=%20.7f\n",y0)
      t = [t0,              t0+0.1        ]
      y = [func.call(t[0]), func.call(t[1])]
      # printf("t=%20.7f,L=%20.7f\n",t[1],y[1])

      # ߎl2(1֐ɂߎ)
      t << (y0 ? (t[1]-t[0])/(y[1]-y[0])*(y0-y[0])+t[0] : t0-0.1)

      # JԂ
      i = 10
      while ((t[2]-t[1]).abs > 1E-6) && (i > 0)
        # \vZ
        y << func.call(t[2])
        break if y0 && (y[2]-y0).abs <= 1E-7

        # printf("t=%20.7f,L=%20.7f\n",t[2],y[2])
        t01     = t[0]-t[1]
        t02,y02 = t[0]-t[2], y[0]-y[2]
        t12,y12 = t[1]-t[2], y[1]-y[2]

        # 2֐̌W
        a = ( y02     / t02 - y12     / t12) / t01
        b = (-y02*t12 / t02 + y12*t02 / t12) / t01
        c = y[2]

        if y0
          # ʎ
          if (d = b*b-4*a*(c-y0)) < 0
            i = -1
            break
          end

          # ߎl(2֐ɂߎ)
          sqrtd = Math.sqrt(d)
          sqrtd = -sqrtd if b < 0
          t << (t[2] + 2*(y0-c)/(b+sqrtd)) # <-
        else
          t << (t[2] - b / (2*a))
        end

        t.shift
        y.shift
      end
      $stderr.puts "܂̂ŁAf[^͕ۏ؂ł܂" if i<=0
      return t[2]
    end
  end # of class method

=begin ***********
#--- Ephemeris.new([quality={}])
\  Ephemeris+IuWFNg𐶐ĕԂ܂B
\
\    quality  `nbV
=end =============
  def initialize(quality={})
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==pubN CX^X \bh:                           #
$==Public Instance Method:                                     #
=end ###########################################################
  public

=begin ***********
#--- Ephemeris#time_to_cn(time)
\  ԍɕϊĕԂ܂B
\
\    time  EXʓ
=end =============
  def time_to_cn(time)
    ret = @Proc.call(time.to_f)
  end

=begin ***********
#--- Ephemeris#cn_to_time(cn)
\  ԍɕϊĕԂ܂B
\
\    cn  ԍ
=end =============
  def cn_to_time(cn, time0=nil)
    time0 ||=  (cn - @CN0M) / @CN1M
    type.root(cn, time0) {|x| time_to_cn(x)}
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Ephemeris#_lambda_sun(t)
#--- Ephemeris#_lambda_moon(t)
#--- Ephemeris#_lambda_lunation(t)
#--- Ephemeris#_mean_sun(t)
#--- Ephemeris#_mean_moon(t)
#--- Ephemeris#_mean_lunation(t)
\  zƌ̎o(),ωo()Ԃ܂B
\
\    t   EXʓ
=end =============
  def _lambda_sun(t)      @Location.lambda_sun(t)                          end
  def _lambda_moon(t)     @Location.lambda_moon(t)                         end
  def _lambda_lunation(t) @Location.lambda_moon(t)-@Location.lambda_sun(t) end
  def _mean_sun(t)        @Location.mean_sun(t)                            end
  def _mean_moon(t)       @Location.mean_moon(t)                           end
  def _mean_lunation(t)   @Location.mean_moon(t) - @Location.mean_sun(t)   end

=begin ***********
#--- Ephemeris#_lambda_lunation_to_sun(cn)
\  ]ԍ𑾗zNԍɕϊĕԂ܂B
\
\    cn  ԍ
=end =============
  def _lambda_lunation_to_sun(cn)
    _lambda_sun(type.root(cn, (cn - @LL0M) / @LL1M) {|x| _lambda_lunation(x)})
  end

=begin ***********
#--- Ephemeris#_lambda_sun_to_lunation(cn)
\  zNԍ]ԍɕϊĕԂ܂B
\
\    cn  ԍ
=end =============
  def _lambda_sun_to_lunation(cn)
    _lambda_lunation(type.root(cn, (cn - @LS0M) / @LS1M) {|x| _lambda_sun(x)})
  end

=begin ***********
#--- Ephemeris#_qualify
\  Ephemeris+IuWFNg̐`ݒ肵܂B
\
\  @Title     = Ephemeris.get ̃L[ƂȂV̈ʒu
\  @Formula   = vZΏ/̎w
\  @Location  = ϑn
\  @Proc      = vZ葱
\  @CN0M      =  t =       0 ł̌vZΏێԍ
\  @CN1M      =  t = 1000000 ł̌vZΏێԍ
\  @LM0M      =  t =       0 ł̍]ԍ
\  @LM1M      =  t = 1000000 ł̍]ԍ
\  @LS0M      =  t =       0 ł̑zNԍ
\  @LS1M      =  t = 1000000 ł̑zNԍ
=end =============
  def _qualify

    if String === @Location
      unless @Location = Location.get(@Location)
        raise ArgumentError, 'invalid location name'
      end
    end
    @Formula  ||= '1S'

    @Proc     ||=
      if Hash === @Formula
        @Formula['Rem'] = ((-@Formula['Epoch']).moddiv(@Formula['Period']))[0]
        Proc {|t| (t + @Formula['Rem'])/ @Formula['Period'] }
      else
        @Location ||= Location.get('Tokyo')
        @Title    ||= @Formula + '_' + @Location.name 
        case @Formula
        when /^(\d+)L=>(\d+)S$/
          m, s = $1.to_i, $2.to_i
          @LL0M = _lambda_lunation(      0)
          @LL1M = _lambda_lunation(1000000)
          @LL1M = (@LL1M - @LL0M) / 1000000
          proc {|t| s * _lambda_lunation_to_sun(t/m) }
        when /^(\d+)S=>(\d+)L$/
          s, m = $1.to_i, $2.to_i
          @LS0M = _lambda_sun(      0)
          @LS1M = _lambda_sun(1000000)
          @LS1M = (@LS1M - @LS0M) / 1000000
          proc {|t| m * _lambda_sun_to_lunation(t/s) }
        when /^(\d+)S$/; s=$1.to_i; proc{|t| s * _lambda_sun(t)     }
        when /^(\d+)s$/; s=$1.to_i; proc{|t| s *   _mean_sun(t)     }
        when /^(\d+)M$/; m=$1.to_i; proc{|t| m * _lambda_moon(t)    }
        when /^(\d+)m$/; m=$1.to_i; proc{|t| m *   _mean_moon(t)    }
        when /^(\d+)L$/; m=$1.to_i; proc{|t| m * _lambda_lunation(t)}
        when /^(\d+)l$/; m=$1.to_i; proc{|t| m *   _mean_lunation(t)}
        when /^(.+?)([DXYZTPN])$/
          p, f = $1, $2; proc{|t| @Location.coordinate(t,1,p)[f]}
        when /^(.+?)([dxyztpn])$/
          p, f = $1, $2; proc{|t| @Location.coordinate(t,2,p)[f]}
        when /^(.+?)([ah])$/
          p, f = $1, $2; proc{|t| @Location.coordinate(t,3,p)[f]}
        end
      end

    @CN0M = time_to_cn(      0)
    @CN1M = time_to_cn(1000000)
    @CN1M = (@CN1M - @CN0M) / 1000000

    if @Title
      @Title = [*@Title]
      @@outfit['Objs'].push(self)
    end
  # super
  end
################################################################
  func :cn_to_time, :time_to_cn
  func :_lambda_lunation_to_sun, :_lambda_sun_to_lunation
end
