# eras.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  EEEEE RRRR    A    SSSS
#  E     R   R  A A  S    
#  EEEE  RRRR  A   A  SSS 
#  E     R  R  AAAAA     S
#  EEEEE R   R A   A SSSS 
#
=begin #########################################################
#=Eras                                                         #
\===̗ԓIɐڑĕ\                       #
$===Calendar list which consists of many calendars             #
#                                                              #
\==X[p[NX:                                             #
$==Super Class:                                                #
#*Calendar+                                                    #
=end ###########################################################

class Eras < Calendar

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- Eras.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      case key
      when /^CEBCE$/i
        Eras.new(
          'Title'=> ['^CE$','^BCE$'],
          'List' => [
             {                 'Calendar' => 'Italy',
              'Era' => 'CE',   'Start' => [      1, 1, 1] },
             {'Era' => 'BCE',  'Sign'  => -1, 'Epoch'=>1,
                               'End'   => [      1, 1, 1] }
           ]
        )
      when /^BCAD$/i
        Eras.new(
          'Title'=> ['^BC$','^AD$'],
          'List' => [
             {                 'Calendar' => 'Italy',
              'Era' => 'BC',   'Sign'  => -1, 'Epoch'=>1  },
             {'Era' => 'AD',   'Start' => [      1, 1, 1] }
           ]
        )
      when /^MTSH$/i
        Eras.new(
          'Title'=> ['^M$','^T$','^S$','^H$'],
          'List' => [
             {                 'Calendar' => 'Gregorian',
              'Era' => 'M 6',  'Start' => [1873, 1, 1] },
             {'Era' => 'T',    'Start' => [1912, 7,30] },
             {'Era' => 'S',    'Start' => [1926,12,25] },
             {'Era' => 'H',    'Start' => [1989, 1, 8]  ,
                               'End'   => [2088, 1, 1] }
           ]
        )
      else; nil
      end
    end

=begin ***********
#--- Eras.calendar_year([cal=Civil.new,] name, b [, d])
#--- Eras.calendar_year([cal=Civil.new,] name, yb, mb, db)
\  Np Eras+IuWFNg𐶐ĕԂ܂B
\
\    cal            @(Calendar+)IuWFNg܂͗@
\    b, yb, mb, db  a(i[z)
\    d              Si[z
=end =============
    def calendar_year(*date)
      date.shift if (cal = Calendar.get(date[0]))
      new({'List'=>[
        if Array === date[1]
          {'Calendar'=> (cal || Civil.new),
           'Name'=>date[0], 'Start'=>date[1], 'End'=>date[2]
          }
        else
          {'Calendar'=> (cal || Civil.new),
           'Name'=>date[0], 'Start'=>date[1..3]
          }
        end
      ]})
    end

=begin ***********
#--- Eras.years_old(name, b [, d])
#--- Eras.years_old(name, yb, mb, db)
\  Np Eras+IuWFNg𐶐ĕԂ܂B
\
\    b, yb, mb, db  a(i[z)
\    d              Si[z
=end =============
    def years_old(name, *date)
      new({'List'=>[
        if Array === date[0]
          {'Calendar'=> Civil.new(
           'YearBorder'=>{'Date'=>date[0][1..-1], 'Offset'=>0}),
           'Name'=>name, 'Birth'=>date[0], 'Death' =>date[1]
          }
        else
          {'Calendar'=> Civil.new(
           'YearBorder'=>{'Date'=>date[1..2], 'Offset'=>0}),
           'Name'=>name, 'Birth'=>date[0..2]}
        end
      ]})
    end
  end

=begin ***********
#--- Eras.new(quality={})
\  Eras+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(*quality)
    if Hash === quality
      quality = quality['List'] ? quality : {'List'=>[quality]}
    elsif Hash === quality[0]
      quality = quality[0]['List'] ? quality[0] : {'List'=>quality}
    else
      quality = {}
    end
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==pubN CX^X \bh:                           #
$==Public Instance Method:                                     #
=end ###########################################################
  public

=begin ***********
#--- Eras#date_to_sd(*date)
\  \znʓɕϊĕԂ܂B
\
\    date \z  N [, [, [, [, [,b [,b̏]]]]]]
=end =============
=begin ***********
#--- Eras#exist?(*date)
\  \ɑΉt݂Ă΁A̒nʓԂ܂B
\  \ɑΉN݂ĂȂ΁Anil Ԃ܂B
\
\    date t\i[z
=end =============
  %w( date_to_sd exist? _m_in_y _d_in_y _d_in_m).each do |f|
    module_eval <<-"end;"
      def #{f}(*date)
        return nil unless (a = Calendar.select(date))
        return a[1].#{f}(*date)
      end
    end;
  end

=begin ***********
#--- Eras#sd_to_date(sd [, n=1 [, off=[0,1]]])
\  nʓ\\̑gɕϊĕԂ܂B
\
\    sd  nʓ
\    n   n Ԗڂ̕\
\    off IN@̕␳([I[,])
=end =============
  def sd_to_date(sd, n=1, off=[0,1])
    a = _find_list_by_sdn(sd, n != 1)
    case n
    when false
      return a.length
    when true
      return a.collect do |list|
        date = list['Calendar'].sd_to_date(sd, 1, [list['Epoch'],list['Sign']])
        [[list['Key'], date[0]], *date[1..-1]]
      end
    when 1..a.length
      list = a[n-1]
      date = list['Calendar'].sd_to_date(sd, 1, [list['Epoch'],list['Sign']])
      return [list['Key'], date[0]], *date[1..-1]
    else
      return nil
    end
  end

=begin ***********
#--- Calendar#sd_to_s(sd [, n=1 [, off=[0,1]]])
\  nʓISO8601gɕϊĕԂ܂B
\
\    sd  nʓ
\    n   n Ԗڂ̓\\̑gɕϊ邩w
\    off IN@̕␳([I[,])
=end =============
  def sd_to_s(sd, n=1, off=[0,1])
    a = _find_list_by_sdn(sd, n != 1)
    case n
    when false
      return a.length
    when true
      return a.collect do |list|
        date = list['Calendar'].sd_to_s(sd, 1, [list['Epoch'],list['Sign']])
        list['Key'] + ' ' + date
      end
    when 1..a.length
      list = a[n-1]
      date = list['Calendar'].sd_to_s(sd, 1, [list['Epoch'],list['Sign']])
      return list['Key'] + ' ' + date
    else
      return nil
    end
  end


=begin ***********
#--- Eras#shift_sd(sd, period)
\  sd  period Ŏw肳ꂽԂunʓԂ܂B
\
\    period ISO8601ԕ 
=end =============
  def shift_sd(sd, period)
    a = _find_list_by_sdn(sd, false)
    return nil if a.length == 0
    return a[0]['Calendar'].shift_sd(sd, period)
  end

=begin #########################################################
\==veNebh CX^X \bh:                       #
$==Prptected Instance Method:                                  #
=end ###########################################################
  protected

=begin ***********
#--- Eras#_m_in_y(*date)
\  w肵NɊ܂܂錎̐Ԃ܂B
\  (^p\̔N͍l܂)
\
\    date \z 
=end =============
  protected :_m_in_y

=begin ***********
#--- Eras#_d_in_y(*date)
\  w肵NɊ܂܂̐Ԃ܂B
\  (^p\̔N͍l܂)
\
\    date \z 
=end =============
  protected :_d_in_y

=begin ***********
#--- Eras#_d_in_m(*date)
\  w肵Ɋ܂܂̐Ԃ܂B
\
\    date \z 
=end =============
  protected :_d_in_m

=begin ***********
#--- Eras#_matched_list(key, all)
\  key Ɉv郊XgzŕԂ܂B
\  key  false ̏ꍇ́A邷ׂẴXgv̂Ƃ܂B
\
\    key  L[
\    all  false ̂Ƃ́A title Ƃ̈vmF܂(super)B
\         true  ̂Ƃ́A list  Ƃ̈vmF܂B
=end =============
  def _matched_list(key, all)
    return super unless all

    a = []
    @List.each do |list|
      if !key || list['Key'] =~ key
        obj = list['Calendar']
        a += (Eras === obj) ? obj._matched_list(key) : [[self, list]]
      end
    end
    return (!key && a.length==0) ? nil : a
  end
  public :_matched_list # for Calendar.get

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Eras#_find_list_by_sdn(sd [, all=false])
\  sd Ŏw肵ɗLȗ@̃XgzŕԂ܂B
\
\    sd  nʓ 
\    all false ȂŏɌXĝݕԂ܂B
\        true  ȂLȂׂẴXgԂ܂B
=end =============
  def _find_list_by_sdn(sd, all=false)
    a = []
    @List.each do |list|
      next if list['Day0'] && list['Day0']  > sd
      next if list['Day1'] && list['Day1'] <= sd
      case list['Calendar']
      when Eras; a += _find_list(sd, all)
      else; a.push(list)
      end
      return a unless all || a.length == 0
    end
    return a
  end

=begin ***********
#--- Eras#_qualify
\  Eras+IuWFNg̐`ݒ肵܂B
\
\*CX^Xϐ @List ̗vf̗vf
\  Key      => ".l.N"Ƃ
\  Nation   =>  
\  Name     =>  l
\  Era      =>  N
\  Calendar =>  NԂ̌vZɗp@IuWFNg
\  Sign     =>  @̔N̏E~w
\  Epoch    =>  @̔ÑItZbg
\  Day0     =>  Jn(nߒʓ)
\  Day1     =>  I(nߒʓ)
\  Form     =>  @o͏
\  (Base)   =>  @̔ÑItZbǧvZɎgrl
\  (Start)  =>  JňvZɎgz
\  (End)    =>  ǏvZɎgz
\  (Birth)  =>  JňvZɎgz
\  (Death)  =>  ǏvZɎgz
=end =============
  def _qualify
    # remember first list
    prev = @List[0].dup

    # repeat for all lists
    @List.each do |now|

      # default value is same as previous list
      ['Nation','Name','Era','Calendar','Form'].each do |k|
        now[k] ||= prev[k]
        now.delete(k) if now[k]=='-'
      end

      # name and etc.
      now['Era'], now['Base'] = $1, $2 if now['Era'] =~ /^(.*?) *([-+0-9]+)$/
      now['Key'] = [now['Nation'], now['Name'], now['Era']].compact.join('.')
      now['Calendar'] = (Calendar.get(now['Calendar']) || Civil.new)

      # biginning configuration
      ['Birth', 'Start'].each do |k|
        case now[k]
        when Numeric
          now['Day0']    = now[k]
          break
        when Array
          now['Base']  ||= {'Birth'=>0, 'Start'=>1}[k]
          now['Epoch']   = now[k][0] - now['Base'].to_i
          now['Day0']    = now['Calendar'].date_to_sd(*now[k]).to_i
          break
        when nil;
        else; raise TypeError, 'invalid Birth/Start date'
        end
      end
      now['Sign']  ||= 1
      now['Epoch'] ||= 0

      # ending configuration
      ['Death','End'].each do |k|
        case now[k]
        when Numeric
          now['Day1'] = now[k] + {'Death'=>1, 'End'=>0}[k]
          break
        when Array
          now['Day1'] = now['Calendar'].date_to_sd(*now[k]).to_i +
                           {'Death'=>1, 'End'=>0}[k]
          break
        when nil;
        else; raise TypeError, 'invalid Death/End date'
        end
      end
      prev['Day1'] ||= now['Day0'] if Numeric === now['Day0']

      # teardown
      ['Start', 'End', 'Birth', 'Death', 'Base'].each do |key|
        now.delete(key)
      end
      prev = now
    end

    @Format     ||= [["%s %4d-","-=*"      ], 
                     ["%02d-",  "-<=>!%&*+"],
                     ["%02dT",  "-=*"      ], 
                     ["%02d:",  "-=*"      ],
                     ["%02d:",  "-=*"      ],
                     ["%02d",   "-=*"      ],
                     [".%02d",  "-=*"      ]]
    super
  end
end

=begin #########################################################
\==f[^\:                                                 #
$==Data structure:                                             #
\                                                              #
\ Eras+IuWFNg̓nbV̔z@Listɐ`ێ #
\ Ă܂Bȉ̃nbV̗vf̐łB                 #
=end ###########################################################

=begin -----------
\=== 'Key' : ÑL[Ƃ镶
\  String ".l.N"
\
\    Calendar.get ŕ񂩂 self 邽߂̃L[ێ܂B
\    {́Aɗvf 'Nation', 'Name', 'Era' ܂B
\    ͗vf 'Nation', 'Name', 'Era' ͎gp܂B
=end -------------

=begin -----------
\=== 'Calendar' : NԂ̌vZɗp@IuWFNg
\  Calendar
\
\    NԂ̌vZɗp@(Calendar+)IuWFNgێ܂B
=end -------------

=begin -----------
\=== 'Sign' : @̔N̏E~w
\  Integer 1 or -1
\
\    uIOvȂǂ̕\L̏ꍇAIWiȗ@Ƃ͔N̏tɂȂ܂B
\    {vf -1 w肷ƁAIWiȗ@ƋtɔN𐔂邱Ƃł
\    ܂B
=end -------------

=begin -----------
\=== 'Epoch' : @̔ÑItZbg
\  Integer
\
\    N 0 NɑN̔ԍw肵܂B
=end -------------

=begin -----------
\=== 'Day0' : Jn(nߒʓ)
\=== 'Day1' : I(nߒʓ)
\  Integer
\
\    N̗LԂnߒʓŎ܂B
\    LԂ͊JnIOłBI͗Lł͂܂B
=end -------------

=begin -----------
\=== 'Start','Birth' : 'Epoch'  'Day0' ̌ɗp郆[Uwpvf
\  Array [N,,]
\
\    N̗LԂ̊Jn'Calendar'ɕێ@ł̔NŎ܂B
\    'Start'ł͊Jn܂ޔNu1NvɂȂ悤ɁA'Birth'ł́AJn
\    ܂ޔNu0NvɂȂ悤ɁA'Epoch'ݒ肵܂B'Day0'ɂ́A
\    ̓ݒ肳܂B
\    ͗vf 'Start', 'Birth' ͍폜܂B
=end -------------

=begin -----------
\=== 'End','Death' : 'Day1' ̌ɗp郆[Uwpvf
\  Array [N,,]
\
\    N̗LԂ̏I'Calendar'ɕێ@ł̔NŎ܂B
\    'End'ł͓'Day1'ɁA'Death'ł͗'Day1'ɐݒ肵܂B
\    ͗vf 'End', 'Death' ͍폜܂B
=end -------------

=begin -----------
\=== 'Form'   : @o͏
\  (݁Agpł)
=end -------------
