# ILSB.rb: written by Takashi SUGA 2002-03-31 v0.3(suchowan@box.email.ne.jp)
#
#  I L      SSSS BBBB 
#  I L     S     B   B
#  I L      SSS  BBBB 
#  I L         S B   B
#  I LLLLL SSSS  BBBB 
#
=begin #############################################################
#=ILSB                                                             #
\===ChAz̃x[X                                     #
\                                                                  #
\==X[p[NX:                                                 #
$==Super Class:                                                    #
#*EMD+                                                             #
=end ###############################################################

class ILSB  < EMD

# White / black  month and leap month identification table

               #[w]/b  [n]/l      #1  #2  #3
  LEAP_MAP  = {[false, false] => [ 0,  0,  0],
               [false, true ] => [-3, -3, -3],
               [true,  false] => [+1, -1, -5],
               [true,  true ] => [-2, -4, -2]}

  LEAP_NAME = [[[ 1, "%s Krsnapaksa"       ],
                [ 0, "%s Suklapaksa"       ],
                [-2, "adhika %s Krsnapaksa"],
                [-3, "adhika %s Suklapaksa"]],
               [[-1, "%s Krsnapaksa"       ],
                [ 0, "%s Suklapaksa"       ],
                [-4, "adhika %s Krsnapaksa"],
                [-3, "adhika %s Suklapaksa"]],
               [[-5, "%s Krsnapaksa"       ],
                [ 0, "%s Suklapaksa"       ],
                [-2, "adhika %s Krsnapaksa"],
                [-3, "adhika %s Suklapaksa"]]]

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################

=begin ***********
#--- ILSB.new([quality={})
\  ILSB+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(quality={})
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==veNebh CX^X \bh:                       #
$==Prptected Instance Method:                                  #
=end ###########################################################
  protected

=begin ***********
#--- ILSB#_date_to_sdn(*date)
\  NEEnߒʓɕϊĕԂ܂B
\
\    date \z  N [, [,]]
=end =============
  def _date_to_sdn(*date)
    y, m, d, = date + [1, 1, 1]
    m = [m, 0] unless Array === m
    s  = 12 * (y+@YearEpoch)  + m[0] - 1 + @CycleOffset
    n  = d + 29 + @Ephemeris[0].cn_to_time(s).moddiv(30)[1] * 30
    n += 15 unless m[1] % 3 == 0
    6.times { |i|  
      dd = _sdn_to_date(n-=30)
      if m == dd[1]
        return n 
      end
    }
    return nil
  end

=begin ***********
#--- ILSB#_sdn_to_date(sdn)
\  nߒʓNEEɕϊĕԂ܂B
\
\    sdn nߒʓ
=end =============
  def _sdn_to_date(sdn)
    t, m = sdn.moddiv(30)
    s    = (0..2).to_a.collect {|i| 
      (@Ephemeris[0].time_to_cn(30*(m+i)) - @CycleOffset).floor + 1
    }

    d = t.floor + 1

    b, n, f = false, false, s[0]==s[1]
    if (t>=15.0)
      d -=  15
      b  = true
      n  = true           if (@IndianStyle >  1)
      f  = (s[1] == s[2]) if (@IndianStyle == 2)
    end

    m = [(n ? s[1] : s[0] ).moddiv(12)[0] + 1,
          LEAP_MAP[[b,f]][@IndianStyle-1]
        ]
    y = (n ? s[1] : s[0] ).moddiv(12)[1]

    return y-@YearEpoch, m, d
  end

=begin ***********
#--- ILSB#_qualify
\  ILSB+IuWFNg̐`ݒ肵܂B
\
\  @Ephemeris[0]  = ʑ̌vZɗp錎 Ephemeris
\  @Timezone[0]   = ʑ̌vZɗp錎 Timezone
\  @CycleOffset   = ʑ̃ItZbg
\  @IndianStyle   = [̕\@
\  @YearEpoch     = Ň
=end =============
  def _qualify

    # ʑ̃ItZbg(6ȈtɌ_܂ł̍΍)
    @CycleOffset  ||= +23.25 / 30
    
    @Ephemeris ||= '30L=>12S_CentralIndia_M'
    unless (@Ephemeris = Ephemeris.get(@Ephemeris))
      @Ephemeris = Ephemeris.get('30L=>12S_CentralIndia_M')
    end

    # g^C][
    @Timezone     ||= -12.0

    @TimeUnits    ||= [nil, nil, 60, 60, 60, 60]

    # [єE̕\@
    @IndianStyle  ||= 1
    @LeapNames    ||= LEAP_NAME[@IndianStyle-1]

    # ̖O
    @MonthNames   ||= %w(
      Caitra     Vaisakha    Jyaistha  Asadha
      Sravana    Bhadrapada  Asvina    Karttika
      Margasira  Pausa       Magha     Phalguna
    )

    # Ň(TJ)
    @YearEpoch    ||=   78
    super
  end

################################################################
  # func :_date_to_sdn, :_sdn_to_date
end
