# jewish.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#       J EEEEE W   W I  SSSS H   H
#       J E     W   W I S     H   H
#       J EEEE  W W W I  SSS  HHHHH
#   J   J E     W W W I     S H   H
#    JJJ  EEEEE  W W  I SSSS  H   H

=begin ##########################################################
#=Jewish                                                        #
\===_                                                    #
$===Jewish Calendar                                             #
#                                                               #
\==X[p[NX:                                              #
$==Super Class:                                                 #
#*FMD+                                                          #
=end ############################################################

class Jewish < FMD

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- Jewish.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      case key
      when /^Jewish$/i
         _NormalIDs   =   [[ 1,0],[ 2,0],[ 3,0],[ 4,0],[ 5,0],[ 6,0], 
                           [ 7,0],[ 8,0],[ 9,0],[10,0],[11,0],[12,0]]
         _LeapIDs     =   [[ 1,0],[ 2,0],[ 3,0],[ 4,0],[ 5,0],[ 6,0], [ 6,2],
                           [ 7,0],[ 8,0],[ 9,0],[10,0],[11,0],[12,0]]
        Jewish.new(
          'Title'     => 'Jewish',
          'DayBorder' =>  18,
          'NormalIDs' =>  _NormalIDs,
          'LeapIDs'   =>  _LeapIDs,
          'MonthNames'=>  %w(  Thischri  Marcheschwan  Kislev  Thebeth
                               Schebath  Adar          Nisan   Ijar
                               Sivan     Thamus        Ab      Elul ),
          'LeapNames' =>  [[0, "%s"], [2, "Veadar", 6]],
          'RuleTable' =>  {
            353 => {'Length'=>[30,29,29,29]   +[30,29]*4, 'IDs'=>_NormalIDs},
            354 => {'Length'=>[30,29,30,29]   +[30,29]*4, 'IDs'=>_NormalIDs},
            355 => {'Length'=>[30,30,30,29]   +[30,29]*4, 'IDs'=>_NormalIDs},
            383 => {'Length'=>[30,29,29,29,30]+[30,29]*4, 'IDs'=>_LeapIDs},
            384 => {'Length'=>[30,29,30,29,30]+[30,29]*4, 'IDs'=>_LeapIDs},
            385 => {'Length'=>[30,30,30,29,30]+[30,29]*4, 'IDs'=>_LeapIDs}
          },

          # Default Parameters
          'YearEpoch'  => 3761,
          'DayEpoch'   => 1721300 + Rational(  9415,  98496),
          'MeanMonth'  =>      29 + Rational(261307, 492480),
          'LeapPeriod' =>   19,
          'LeapNumber' =>    7,
          'LeapBase'   =>    1
        )
      else; nil
      end
    end
  end # of class method

=begin ***********
#--- Jewish.new([quality={})
\  Jewish+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(quality={})
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Jewish#_new_year(y)
\  y Ŏw肵N̎n߂̒nߒʓԂ܂B
\
\    y  N 
=end =============
  def _new_year(y)

    y -=      @YearEpoch
    g  = (y + @LeapBase    ) % @LeapPeriod
    g  = (g * @NoLeapNumber) % @LeapPeriod
    t  =  y * @MeanYear  + g * @DateShift + @DayEpoch
    n  = t.floor
    f  = t - n

    case (n+1) % 7
    when 0,3,5 # Sun, Wed, Fri
      n += 1
    when 1     # Mon
      n += 1 if ((f >= Rational(23269, 25920)) && (g > 11))
    when 2     # Tue
      n += 2 if ((f >= Rational( 1367,  2160)) && (g >  6))
    else       # Thu, Sat
    end
    return n
  end

=begin ***********
#--- Jewish#_qualify
\  Jewish+IuWFNg̐`ݒ肵܂B
\
=end =============
  def _qualify

    # Derived Parameters
    @NoLeapNumber =  @LeapPeriod - @LeapNumber
    @DateShift    =  @MeanMonth  / @LeapPeriod
    @MeanYear = 12 * @MeanMonth  + @LeapNumber*@DateShift

    super
  end
################################################################
  func :_new_year
end
