# japan.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#      J   A   PPPP    A   N   N
#      J  A A  P   P  A A  NN  N
#      J A   A PPPP  A   A N N N
#  J   J AAAAA P     AAAAA N  NN
#   JJJ  A   A P     A   A N   N
#
=begin #########################################################
#=Japan                                                        #
\==={f[^                                             #
=end ###########################################################
module Japan

Date::Extended.calendar_element('\',
  proc{|d| %w( b       M h p  )     [(d.sdn - 11) % 10]})

Date::Extended.calendar_element('\x',
  proc{|d| %w( q N  K C    \    )[(d.sdn - 11) % 12]})

Date::Extended.calendar_element('x', proc{|d| d['\'] + d['\x']})

def self.instance(name)
case name
when 'JapanFMD0'

FMD0.new('Title'=>'JapanFMD0',  'YearEpoch'=>593, 'DayEpoch'=>1937689,
         'RuleTable'=> %w(	aBcDeFgHiJkL	AbCdEfGhIiJkL	aBcDEfGhIjKl
AbCdEfGhIJkL	aBcDeEfGhIjKL	aBcDeFgHiJkL	aBcDEfGhIjKl	AaBcDeFgHIjKl

AbCdEfGhIjKL	aBcDeFgHiJjKl	AbCDeFgHiJkL	aBcDeFgHIjKl	AbCdEfGgHiJKl
AbCdEfGhIjKl	AbCDeFgHiJkL	aBcCdEfGHiJkL	aBcDeFgHiJKl	AbCdEfGhIjKkL
aBCdEfGhIjKl	AbCdEfGHiJkL	aBcDeFgHhIJkL	aBcDeFgHiJkL	aBCdEfGhIjKl
AbCdEeFGhIjKl	AbCdEfGhIJkL	aBcDeFgHiJkL	aBBcDeFgHiJkL	aBcDeFGhIjKl
AbCdEfGhIJjKl	AbCdEfGhIjKl	ABcDeFgHiJkL	aBcDeFGgHiJkL	aBcDeFgHIjKl
AbCdEfGhIjKl	ABcDdEfGhIjKl	AbCdEFgHiJkL	aBcDeFgHIjKlL	aBcDeFgHiJkL
AbCdEfGhIjKl	AbCdEFgHhIjKl	AbCdEfGHiJkL	aBcDeFgHiJkL	AbCdEeFgHiJkL
aBcDEfGhIjKl	AbCdEfGHiJkL	aBbCdEfGhIjKL	aBcDeFgHiJkL	aBcDEfGhIjKkL
aBcDeFgHIjKl	AbCdEfGhIjKL	aBcDeFgGhIjKl	AbCDeFgHiJkL	aBcDeFgHIjKl
AbCcDeFgHiJKl	AbCdEfGhIjKl	AbCDeFgHiJkLl	AbCdEfGHiJkL	aBcDeFgHiJKl

AbCdEfGhIiJkL	aBCdEfGhIjKl	AbCdEfGHiJkL	aBcDeEfGhIJkL	aBcDeFgHiJkL
aBCdEfGhIjKl	AaBcDeFGhIjKl	AbCdEfGhIJkL	aBcDeFgHiJjKl	ABcDeFgHiJkL
aBcDeFGhIjKl	AbCdEfGgHIjKl	AbCdEfGhIjKl	ABcDeFgHiJkL	aBcCdEFgHiJkL
aBcDeFgHIjKl	AbCdEfGhIjKkL	AbCdEfGhIjKl	AbCdEFgHiJkL	aBcDeFgHIiJkL
aBcDeFgHiJkL	AbCdEfGhIjKl	AbCdEFfGhIjKl	AbCdEfGHiJkL	aBcDeFgHiJkL
AbBcDeFgHiJkL	aBcDEfGhIjKl	AbCdEfGHiJjKl	AbCdEfGhIjKL	aBcDeFgHiJkL
aBcDEfGgHiJkL	aBcDeFGhIjKl	AbCdEfGhIjKL	aBcDdEfGhIjKl	AbCDeFgHiJkL
aBcDeFGhIjKlL	aBcDeFgHiJKl	AbCdEfGhIjKl	AbCDeFgHhIjKl	AbCdEFgHiJkL
aBcDeFgHiJKl	AbCdEeFgHijKL	aBCdEfGhIjKl	AbCdEFgHiJkL	aBbCdEfGhIJkL
aBcDeFgHiJKl	aBcDEfgHIjKLl	AbcDeFgHIjKL	aBcdEfgHIjKL	AbCdeFggHiJKL

aBCdeFghIjKL	aBCdEfGhIjkL	AbCdDEfGhIjkL	aBCdEfGHiJkL	abCdEfGHiJKl
AabCdEfGHiJKl	AbcDefGHiJKL	aBcdEfgHhIJKl	ABcdEfgHiJKl	ABcDeFghIjKl
ABCdEfFgHijKl	ABcDEfGhIjkL	aBcDEfGhIJkL	abBcDeFGhIJkL	abCdEfGhIJKl
AbcDefGhIJKkL	AbcDefGhIJkL	ABcdEfgHiJkL	ABcDeFggHiJkL	AbCDeFghIjKl
AbCDeFgHIjkL	aBcDdEFgHIjKl	aBcDeFgHIjKL	abCdeFgHIJkL	AabCdeFgHIjKL
AbcDefGHijKL	AbCdEfgHiIjKL	aBCdEfgHiJkL	AbCdEFghIjKl	AbCDeFfGhIjKl
AbCdEfGHiJkL	aBcdEFgHIjKL	aBccdEfGHiJKl	AbCdeFgHiJKL	aBcDefGhIjKKl
ABcDefGhIjKl	ABCdEfgHiJkL	aBCdEfGgHiJkL	aBcDEfGhIjKl	AbCdEfGHiJkL
aBccDeFGhIJkL	aBcdEfGhIJKl	AbCdeFgHiJKL	aAbCdeFghIJkL	ABcDefGhiJKl
ABcDEfgHiIjKl	AbCDeFgHiJkL	aBcDeFGhIjKl	AbcDEeFgHIjKl	AbcDeFgHIJkL

aBcdEfGhIJkL	AbCcdEfgHIjKL	AbCdeFghIJkL	ABcDefGhiJjKL	AbCdEfGhiJkL
AbCDeFgHiJkL	aBcDeFGhHiJkL	abCdEFgHIjKl	AbcDeFgHIjKL	aBcdDefGHiJKL
aBcdEfGhIjKl	ABCdeFghIjKLl	ABCdeFghIjKL	aBCdEfGhiJkL	aBCdEFgHiJjkL
aBCdEfGHiJkL	abCdEfGHiJKl	AbcDeFfGhIJKl	AbcDefGhIJKL	aBcdEfgHiJKL
aBCcdEfgHiJKl	ABcDeFghIjKL	aBcDEfGhIjkKL	aBcDeFGhIjkL	aBcDEfGHiJkL
abCdEfGHhIJkL	aBcdEfgHIJkL	AbCDefghIJKl	ABcDeefGhIJKL	aBcdEfgHiJKL
aBcDeFghIjKl	AAbCDeFghIjKl	ABcDeFGhIjkL	aBcDeFGhIiJKl	aBcDeFgHIJkL
abCdEfgHIjKL	AbCdeeFgHiJKL	aBcDefGhIjKL	AbCdEfgHiJkL	ABcCdEfGhiJkL
aBCDeFghIjKl	ABcdEFgHIjKkl	AbCdEfGHiJkL	aBcdEfGHiJKL	abCdeFgGHiJKL
abCdeFgHiJKL	aBcDefGhIjKL	AbCdEefGhiJKL	aBCdEfgHiJkL	aBCdEfGhIjKl

AaBcDeFGhIjKl	AbcDEfGHiJkL	aBcdEfGHiJJkL	aBcdEfGhIJKl	AbCdeFghIJKL
aBcDefFghIJKL	aBcDefGhIjKl	ABcDEfgHijKL	aBbCDeFgHiJkL	aBcDeFGhIJkl
AbcDeFGhIJkLl	AbcDeFgHIJkL	aBcdEfGhIJkL	AbCdeFggHIjKL	AbCdeFghIjKL
AbCDefGhiJKl	AbCDdEfGhIjkL	AbCDeFgHiJkL	aBcDeFgHIjKl	AAbcdEFgHIjKl
AbcDeFgHIjKL	AbcdEfgHIiJKL	aBcdEfgHIjKL	aBCdeFghIjKL	AbCdEfGghIjKl
ABCdEfGhiJkL	aBCdEfGHiJkL	AbccDEfGHiJkL	abCdEfGHiJKl	AbcDEfgHiJKLl
AbcDefGHiJKL	AbcdEfgHiJKL	aBCdeFggHiJKl	ABcDeFghIjKL	aBcDEfGhiJkL
aBcDEeFGhIjkL	aBcDeFGhIJkL	abCdEfGHiJKl	AabCdeFGhIJKl	AbcDefGhIJKl
ABcdEfgHiIJkL	ABcdEfgHiJKl	ABcDeFghIjKl	ABcDEfGgHijKl	AbCDeFgHIjKl
aBcDeFGhIJkL	abCcDeFgHIJkL	abCdeFgHIJkL	AbcDefGhIJkLL	AbcDefGhIjKL

AbCdEfgHiJkL	AbCDeFghHiJkL	aBCdEFghIjKl	AbCdEFgHiJKL	abcDdEfGHiJKl
aBcdEfGHIjKL	abCdeFgHIjKL	AbbCdeFgHiJKL	aBcDefGhIjKL	AbCdEfgHiJJkL
aBCdEfgHiJkL	AbCdEFgHijKl	AbCDeFfGhIJkl	AbCdEfGHiJKl	AbcDeFgHIjKL
aBccdEfGHiJKL	aBcdeFgHiJKL	aBCdefGhIjKLl	ABcDeFghIjKL	aBCdEfGhiJkL
aBCdEfGhHiJkL	aBcDEfGhIjKL	abCdEfGHiJKL	abcDdeFGhIJkL	AbcdEfGhIJKl
ABcdeFgHiJKl	ABbCdeFgHiJkL	ABcDefGhIjKl	ABcDEfgHiJjKl	AbCDeFgHiJkL
aBcDeFGhIjKl	AbCdEfGgHIjKl	AbCdeFgHIJkL	aBcdEfGhIJkL	AbCcDefGhIjKL
AbCdEfghIJkL	ABcDefGhIjKkL	AbCdEfGhIjKl	AbCdEFgHiJkL	aBcDeFgHIiJkl
ABcdEfGHIjKL	abCdeFgHIjKL	aBcDeeFgHiJKL	aBcdEfgHIjKL	AbCdEfghIjKL
AaBCdeFgHijKL	aBCdEfGhIjKl	AbCdEFgHiJjKl	AbCdEfGHiJkL	abCdEfGHiJKl

AbCdeFfGhIJKl	AbCdefGHiJKL	aBcDefgHiJKL	aBCcDefgHiJKl	ABcDeFgHijKL
aBcDEfGhIjkLl	ABcDeFGhIjKl	aBcDeFGhIJkL	abCdEfGhHIJkL	aBcdEfGhIJKl
AbCdefGhIJKl	ABcDeefGhIJkL	ABcdEfgHiJkL	ABcDeFgHijKl	ABbCDeFgHijKl
AbCDeFgHIjKl	aBcDeFGhIJjKl	aBcDeFgHIjKL	aBcdeFgHIJkL	AbCdefFgHIjKL
AbCdefGhIjKL	AbCdEfgHiJkL	AbCDdEfgHiJkL	aBCdEFghIjKl	AbCdEFgHiJKll
AbCdEfGHiJKl	aBcDefGHIjKL	aBcdeFgHHiJKL	aBcdeFgHiJKL	aBcDefGhIjKL
aBCdEefGhIjKl	ABCdEfgHiJkL	aBCdEfGhIjKl	AaBcDEfGhIjKl	AbCdEfGHiJkL
aBcdEfGHiJKkl	ABcdEfGhIJkl	ABCdeFgHiJKl	ABcDefGgHiJkL	ABcDefGhIjKl
ABcDEfgHiJkL	aBcCDeFgHijKL	aBcDeFGhIjKl	AbCdeFGhIJkLl	AbcDeFgHIJkL
aBcdEfGhIJkL	AbCdeFggHIjKL	AbCdeFghIJkL	AbCDefGhiJKl	AbCDeEfGhIjKl

AbCDeFgHiJkL	aBcDeFgHIjKl	AabCdEfGHIjKl	AbcDeFgHIjKL	aBcdEfgHIiJKL
aBcdEfgHIjKL	AbCdeFghIjKL	AbCdEfGghIjKL	aBCdEfGhIjkL	AbCdEFgHiJkL
abCcDEfGHiJkL	abCdEfGHiJKl	AbcDeFgHiJKLl	AbcDefGhIJKl	ABcdEfgHiJKL
aBCdeFghHiJKl	ABcDeFghIjKL	aBcDEfGhIjkL	aBCdEeFGhIjKl	aBcDeFGhIJkL
abCdEfGhIJKl	AbbCdeFGhIJKl	AbcDefGhIJKl	ABcdEfgHiJJkL	AbCdEfghIJkL
ABcDeFghIjKl	ABcDEfGghIjKl	AbCDeFgHIjKl	aBcDeFGhIJkL	abCcDeFgHIjKL
abCdeFgHIJkL	AbcDefGhIJkLL	aBcDefGhIjKL	AbCdEfgHiJkL	AbCDeFghHiJkL
aBCdEfGhIjKl	AbCdEFgHiJkL	aBcDeEfGHiJKl	aBcdEfGHIjKL	abCdeFgHIjKL
AbbCdeFgHiJKL	aBcDefGhIjKL	aBCdEfgHiJjKl	ABcDeFgHiJkL	aBCdEfGhIjKl
AbCdEfGGhIjKl	AbcDeFGHiJkL	aBcdEfGHiJKl	AbCcdEfGhIJKl	AbCdeFgHiJKl

ABcDefGhiJKLl	ABcDefGhiJKl	ABcDeFgHiJkL	aBcDEfGhIiJkL	aBcDeFGhIjKl
AbcDeFGhIJkL	aBcdEeFgHIJkL	aBcdEfGhIJkL	AbCdeFghIJkL	ABbCdeFghIJkL
AbCDefGhiJKl	AbCDeFgHiJjKl	AbCdEFgHiJkL	abCDeFgHIjKl	AbcDeFfGHIjKl
AbcDeFgHIjKL	aBcdEfgHIjKL	AbCddEfgHIjKL	AbCdeFghIjKL	AbCdEfGhiJkLL
aBCdEfGhIjkL	AbCdEFgHiJkL	abCdEFgHIiJkL	abCdEfGHiJKl	AbcDeFgHiJKL
aBcdEefGHiJKL	aBcdEfgHiJKL	aBCdeFghIjKL	aBBcDeFghIjKL	aBcDEfGhIjkL
aBCdEfGHiJjKl	aBcDeFGhIJkL	abCdEfGhIJKl	AbcDefFGhIJKl	AbcDefGhIJKl
ABcdEfgHiJKl	ABCddEfgHiJkL	ABcDeFghIjKl	ABcDeFGhiJkLl	AbCDeFgHIjKl
aBcDeFGhIjKL	abCdEfGhIIjKL	abCdeFgHIJkL	AbcDefGhIJkL	AbCdEefGhIjKL
AbCdEfgHiJkL	AbCDeFghIjKl	AaBCdEfGhIjKl	AbCdEFgHiJkL	aBcDeFgHIjjKL

aBcdEfGHIjKL	abCdeFgHIjKL	aBcDefGgHiJKL	aBcDefGhIjKL	aBCdEfgHiJkL
aBCcDEfgHiJkL	aBCdEfGhIjKl	AbCdEfGHiJkLl	AbCdEfGHiJkL	aBcdEfGHiJKl
AbCdeFgHhIJKl	AbCdeFgHiJKl	ABcDefGhIjKl	ABCdEefGhiJKl	ABcDeFgHiJkL
aBcDEfGhIjKl	AaBcDeFGhIjKl	AbcDeFGhIJkL	aBcdEfGhIJjKL	aBcdEfGhIJkL
AbCdeFghIJkL	ABcDefGghIJkL	AbCDefGhiJKl	AbCDeFgHiJkL	aBcDdEFgHiJkL
abCDeFgHIjKl	AbcDeFgHIJkLl	AbcDeFgHIjKL	aBcdEfgHIjKL	AbCdeFghHiJKL
aBCdeFghIjKL	AbCDefGhiJkL	AbCDeFfGhIjkL	aBCdEfGHiJkL	abCdEFgHIjKl
AbbCdEfGHiJKl	AbcDefGHiJKL	aBcdEfgHiJJKl	ABcdEfgHiJKL	aBCdeFghIjKL
aBCdEfGghIjKl	ABcDEfGhiJkL	aBcDEfGhIJkl	AbCcDeFGhIJkl	AbCdEfGhIJKl
AbcDefGhIJKl	AAbcDefGhIJKl	ABcdEfgHiJKl	ABcDeFghIiJkL	ABcDeFghIjKl

ABcDeFGhiJkL	aBcDEeFgHiJkL	aBcDeFGhIjKL	abCdeFGhIJkL	AbbCdeFgHIJkL
AbcDefGhIJkL	AbCdEfgHiJjKL	AbCdEfgHiJkL	AbCDeFghIjKl	AbCDeFgGhIjKl
AbCdEFgHiJkL	aBcDeFgHIjKL	abCcdEfGHIjKL	abCdeFgHiJKL	aBcDefGhIjKL
AaBcDefGhIjKL	aBCdEfgHiJkL	aBCdEfGhIiJkL	aBcDEfGhIjKl	AbCdEfGHiJkL
aBcdEeFGHiJkL	aBcdEfGHiJKl	AbCdeFgHiJKL	aBbCdeFghIJKl	ABcDefGhiJKl
ABCdEfgHijJKl	ABcDeFgHiJkL	aBcDEfGhIjKl	AbCdEfGgHIjKl	AbcDeFGhIJkL
aBcdEfGhIJKl	AbCddEfgHIJkL	AbCdeFghIJkL	ABcDefGhiJKlL	AbCdEfGhiJkL
AbCDeFgHiJkl	ABcDeFGhIiJkl	AbCdEFgHIjKl	AbcDeFgHIJkL	aBcdEeFgHIjKL
aBcdEfgHIjKL	AbCdeFghIjKL	AbBCdeFghIjKL	aBCdEfGhiJkL	AbCDeFgHijJkL
aBCdEfGHiJkl	AbCdEFgHiJKl	AbcDeFfGHiJKl	AbcDefGHiJKL	aBcdEfgHiJKL

aBCddEfgHiJKL	aBcDeFghIjKL	aBCdEfGhiJkLl	ABcDEfGhiJkL	aBcDEfGhIJkl
AbCdEfGHiIjKl	AbCdEfGhIJKl	AbcDefGhIJKl	ABcdEefGhIJKl	ABcdEfgHiJKl
ABcDeFghIjKl	ABbCDeFghIjKl	ABcDeFgHiJkL	aBcDeFGhIjjKL	aBcDeFgHIjKL
abCdeFGhIJkL	AbcDefGgHIJkL	AbcDefGhIjKL	AbCdEfgHiJkL	ABcDdEfgHiJkL
AbCDefGhIjKl	AbCDeFgHiJkLl	AbCdEFgHiJkL	aBcDeFgHIjKl	AbCdeFgHIiJKl
AbCdeFgHiJKL	aBcDefGhIjKL	AbCdEffGhIjKL	aBCdEfgHiJkL	aBCdEfGhIjKl
AbBcDEfGhIjKl	AbCdEfGHiJkL	aBcdEfGHiJjKL	aBcdEfGHiJKl	AbCdeFgHiJKL
aBcDefGghIJKl	ABcDefgHiJKl	ABCdeFgHijKL	aBCdDeFgHiJkL	aBcDEfGhIjKl
AbcDEfGHiJkLl	AbcDeFGhIJkL	aBcdEfGhIJKl	AbCdeFghHIJkL	AbCdefGhIJkL
ABcDefGhiJKl	ABcDeFfGhiJkL	AbCDeFgHijKl	ABcDeFGhIjKl	aBbCdEFgHIjKl

AbcDeFgHIJkL	aBcdEfgHIJjKL	aBcdeFgHIjKL	AbCdefGhIjKL	AbCDefGghIjKL
aBCdEfGhiJkL	AbCDeFgHijKl	AbCDdEfGHiJkl	AbCdEfGHiJKl	AbcDeFgHIjKL
aAbcDefGHiJKL	aBcdeFgHiJKL	aBCdeFghIiJKL	aBcDeFghIjKL	aBCdEfGhiJkL
aBCdEFfGhiJkL	aBcDEfGhIJkl	AbCdEfGHiJKl	AbbCdeFGhIJKl	AbcDefGhIJKl
ABcdEfgHiJjKL	AbCdEfgHiJKl	ABcDeFghIjKl	ABcDEfGghIjKl	ABcDeFgHiJkL
aBcDeFGhIjKl	AbCcDeFgHIjKl	AbCdeFgHIJkL	AbcDefGhIJKl	AaBcDefGhIjKL
AbCdEfgHiJkL	ABcDeFghIiJkL	AbCDefGhIjKl	AbCDeFgHiJkL	aBcDeFFgHiJkL
aBcdEFgHIjKl	AbCdeFgHIjKL	aBbCdeFgHiJKL	aBcDefGhIjKL	AbCdEfghIjJKL
aBCdeFgHijKL	aBCdEfGhIjKl	AbCdEFggHIjKl	AbCdEfGHiJkL	aBcdEfGHiJKl
AbCddEfGhIJKl	AbCdeFgHiJKL	aBcDefgHiJKLl	ABcDefgHiJKl	ABcDeFgHijKL

aBCdEfGhIijKL	aBcDeFGhIjKl	aBcDEfGhIJkL	aBcdEeFGhIJkL	aBcdEfGhIJKl
AbCdefGhIJKl	ABcCdefGhIJkL	ABcDefgHiJKl	ABcDeFgHijjKL	AbCDeFgHijKl
ABcDeFGhIjKl	aBcDeFGgHIjKl	aBcDeFgHIJkL	aBcdEfgHIJkL	AbCddeFgHIjKL
AbCdefGhIjKL	AbCdEfgHiJkL	AaBCdEfGhiJkL	AbCdEFgHijKl	AbCDeFgHIijKl
AbCdEfGHiJKl	aBcDeFgHIjKL	aBcdeEfGHiJKL	aBcdeFgHiJKL	aBCdefGhIjKL
AbCcDefGhIjKL	aBCdEfGhiJkL	aBCdEfGhIjjKL	aBcDEfGhIjKl	AbCdEfGHiJKl
aBcDefGGhIJKl	AbcdEfGhIJKl	ABcdeFgHiJKL	aBcDdeFgHiJKl	ABcDefGhIjKl
ABcDEfgHiJkLl	AbCDeFgHiJkL	aBcDeFGhIjKl	AbCdEfGhIJjKl	AbCdeFgHIJkL
AbcdEfGhIJKl	AbCdeFfGhIjKL	AbCdEfghIJkL	ABcDefGhIjKl	ABbCdEfGhIjKl
AbCDeFgHiJkL	aBcDeFGhIjjKL	aBcdEFgHIjKl	AbcDeFgHIjKL	aBcDefGgHiJKL

aBcDefgHIjKL	AbCdEfghIjKL	AbCDdeFgHijKL	aBCdEfGhIjKl	AbCdEFgHiJkLl
AbCdEfGHiJkL	abCdEfGHiJKl	AbcDeFgHhIjKL	AbCdefGHiJKL	aBcDefgHiJKL
aBCdeFfgHiJKl	ABcDeFgHijKL	aBCdEfGhIjkL	aBCcDeFGhIjKl	aBcDeFGhIJkL
abCdEfGHijjKL	AbCdEfGhIJKl	AbCdefGhIJKl	ABcDefgGhIJkL	ABcdEfgHiJKl
ABcDeFghIjKl	ABcDEeFgHijKl	AbCDeFgHIjKl	aBcDeFGhIJkL	aaBcDeFgHIjKL
aBcdeFgHIJkL	AbCdefGhIIjKL	AbCdefGhIjKL	AbCdEfgHiJkL	AbCDeFfgHiJkL
AbCdEFgHijKl	AbCdEFgHiJKl	aBbCdEfGHiJKl	aBcDeFgHIjKL	aBcdeFgHIjjKL
AbCdeFgHiJKL	aBcDefGhIjKL	AbCdEfggHIjKL	aBCdEfgHiJkL	aBCdEfGhIjKl
AbCdDEfGhIjKl	AbCdEfGHiJKl	aBcdEfGHiJKl	ABbcdEfGhIJKl	AbCdeFgHiJKL
aBcDefGhIiJKl	ABcDefGhIjKl	ABcDEfgHiJkL	aBcDEfFgHiJkL	aBcDeFGhIjKl

AbCdeFGhIJkL	aBbcDeFgHIJkL	aBcdEfGhIJKl	AbCdeFghIJjKL	AbCdeFghIJkL
ABcDefGhiJKl	ABcDeFggHIjKl	AbCDeFgHiJkL	aBcDeFgHIjKl	AbcDdEFgHIjKl
AbcDeFgHIjKL	aBcdEfGhIjKL	AaBcdEfgHIjKL	AbCdeFghIjKL	AbCDefGhiIjKL
aBCdEfGhIjkL	AbCdEFgHiJkL	abCdEFfGHiJkL	abCdEfGHiJKl	AbcDeFgHiJKL
aBccDefGHiJKL	aBcdEfgHiJKL	aBCdeFghIjjKL	AbCDeFghIjKL	aBCdEfGhIjkL
aBCdEfGgHIjKl	aBcDeFGhIJkL	abCdEfGHiJKl	AbcDdeFGhIJKl	AbcDefGhIJKl
ABcdEfgHiJKl	AAbCdEfgHiJkL	ABcDeFghIjKl	ABcDEfGhIijKl	AbCDeFgHIjKl
aBcDeFGhIJkL	abCdEeFgHIjKL	abCdeFgHIJkL	AbCdefGhIJkL	ABccDefGhIjKL
AbCdEfgHiJkL	AbCDeFghIjjKL	aBCdEfGhIjKl	AbCdEFgHiJkL	aBcDeFggHIJkL
aBcDefGHIjKL	abCdeFgHIjKL	AbcDdeFgHiJKL	aBcDefGhIjKL	aBCdEfgHiJkL

AaBCdEfgHiJkL	aBCdEfGhIjKl	AbCdEFgHiJjKl	AbCdEfGHiJkL	aBcdEfGHiJKl
AbCdeFfGhIJKl	AbCdeFgHiJKL	aBcDefGhIjKL	aBCcDefGhIjKl	ABcDeFgHiJkL
aBcDEfGhIjjKL	aBcDeFGhIjKl	AbcDeFGhIJkL	aBcdEfGgHIJkL	aBcdEfGhIJKl
AbCdeFghIJkL	ABcDeeFghIJkL	AbCDefGhiJKl	ABcDeFgHiJkL	aAbCdEFgHiJkL
aBcDeFgHIjKl	AbcDeFgHIJjKl	AbcDeFgHIjKL	aBcdEfgHIjKL	AbCdeFfgHIjKL
AbCdeFghIjKL	AbCdEfGhiJkL	AbCCdEfGhIjkL	AbCdEFgHiJkL	abCdEFgHIjKkL
abCdEfGHiJKl	AbcDeFgHiJKL	aBcdEfgGhIJKl	ABcdEfgHiJKL	aBCdeFghIjKL
aBCdEeFghIjKL	aBcDEfGhIjkL	aBCdEfGHiJkL	aaBcDeFGhIJkL	abCdEfGhIJKl
AbcDefGHiIjKL	AbcDefGhIJKl	ABcdEfgHiJKl	ABcDeFfgHiJkL	ABcDeFghIjKl
ABcDEfGhiJkL	aBbCDeFgHIjKl	aBcDeFGhIJkL	abCdEfGhIjjKL	AbCdeFgHIJkL

AbcDefGhIJkL	ABcdEfgHhIjKL	AbCdEfgHiJkL	AbCDeFghIjKl	AbCDdEfGhIjKl
AbCdEFgHiJkL	aBcDeFgHIjKL	aaBcdEfGHIjKL	abCdeFgHIjKL	AbcDefGhIiJKL
aBcDefGhIjKL	aBCdEfgHiJkL	aBCDeFfgHiJkL	aBCdEfGhIjKl	AbCdEfGHiJkL
aBbCdEfGHiJkL	aBcdEfGHiJKl	AbCdeFgHiJjKL	AbCdeFgHiJKL	aBcDefGhiJKl
ABCdEfgHhiJKl	ABcDeFgHiJkL	aBcDEFghIjKl	AbCdEeFGhIjKl	AbcDeFGhIJkL
aBcdEfGhIJKl	AaBcdEfGhIJkL	AbCdeFghIJkL	ABcDefGhiIjKL	AbCDefGhiJKl
AbCDeFgHiJkL	aBcDeFGgHiJkL	abCDeFgHIjKl	AbcDeFgHIJkL	aBccDeFgHIjKL
aBcdEfgHIjKL	AbCdeFghIJkKL	AbCdeFghIjKL	AbCdEfGhiJkL	AbCDeFgHhIjkL
AbCdEFgHiJkL	abCdEFgHIjKl	AbcDdEfGHiJKl	AbcDefGHiJKL	aBcdEfgHiJKL
AbBcdEfgHiJKL	aBCdeFghIjKL	aBCdEfGhiJjKl	ABcDEfGhiJkL	aBCdEfGHiJkl

AbCdEfFGhIJkL	abCdEfGhIJKl	AbcDefGHiJKL	aBccDefGhIJKl	ABcdEfgHiJKl
ABcDeFghIjKkL	ABcDeFghIjKl	ABcDeFGhiJkL	aBcDEfGhHiJkL	aBcDeFGhIjKL
abCdeFGhIJkL	AbcDdeFgHIJkL	AbcDefGhIJkL	AbCdEfgHiJkL	ABbCdEfgHiJkL
AbCDeFghIjKl	AbCDeFgHiJjKl	AbCdEFgHiJkL	aBcDeFgHIjKL	abCdeFfGHIjKL
abCdeFgHIjKL	aBcDefGhIjKL	AbCcDefGhIjKL	aBCdEfgHiJkL	aBCdEfGhIjKkL
aBCdEfGhIjKl	AbCdEfGHiJkL	aBcdEFgHIiJkL	aBcdEfGHiJKl	AbCdeFgHiJKL
aBcDeeFgHiJKl	ABcDefGhiJKl	ABCdEfgHijKL	aABcDeFgHiJkL	aBcDEfGhIjKl
AbCdEfGHiJjKl	AbcDeFGhIJkL	aBcdEfGhIJKl	AbCdeFfGhIJkL	AbCdeFghIJkL
ABcDefGhiJKl	ABcCdEfGhiJKl	AbCDeFgHiJkl	ABcDeFGhIjKkL	abCdEFgHIjKl
AbcDeFgHIJkL	aBcdEfGgHIjKL	aBcdEfgHIjKL	AbCdeFghIjKL	AbCDeeFghIjKL

AbCdEfGhiJkL	AbCDeFgHijKl	AaBCdEfGHiJkl	AbCdEFgHIjKl	AbcDeFgHIjjKL
AbcDefGHiJKL	aBcdEfgHiJKL	AbCdeFfgHiJKL	aBcDeFghIjKL	aBCdEfGhiJkL
aBCcDEfGhiJkL	aBcDEfGhIJkl	AbCdEfGHiJKlL	abCdEfGhIJKl	AbcDefGhIJKL
aBcdEfgHhIJKl	ABcdEfgHiJKl	ABcDeFghIjKl	ABCdEeFghIjKl	ABcDeFgHiJkL
aBcDEfGhIjKl	AaBcDeFGhIjKL	abCdeFGhIJkL	AbcDefGhIJKkL	AbcDefGhIJkL
AbCdEfgHiJkL	ABcDeFggHiJkL	AbCDeFghIjKl	AbCDeFgHiJkL	aBcCdEFgHiJkL
aBcDeFgHIjKl	AbCdeFgHIJkL	AabCdeFgHIjKL	aBcDefGhIjKL	AbCdEfgHhIjKL
aBCdEfgHiJkL	aBCdEfGhIjKl	AbCdEEfGhIjKl	AbCdEfGHiJkL	aBcdEfGHIjKl
AaBcdEfGHiJKl	AbCdeFgHiJKL	aBcDefGhiIJKl	ABcDefGhiJKl	ABCdeFgHijKL
aBCdEfGgHiJkL	aBcDEfGhIjKl	AbCdEfGHiJkL	aBccDeFGhIJkL	aBcdEfGhIJKl

AbCdeFghIJKkL	AbCdefGhIJkL	ABcDefGhiJKl	ABcDeFgHhiJkL	AbCDeFgHijKl
ABcDeFGhIjKl	aBcDdEFgHIjKl	AbcDeFgHIJkL	aBcdEfGhIJkL	AbBcdeFgHIjKL
AbCdefGhIjKL	AbCDefGhiJjKL	AbCdEfGhiJkL	AbCDeFgHijKl	AbCDeFfGHiJkl
AbCdEFgHiJKl	AbcDeFgHIjKL	aBccDefGHiJKL	aBcdeFgHiJKL	aBCdeFghIjKLL
aBcDeFghIjKL	aBCdEfGhiJkL	aBCdEFgHhiJkL	aBcDEfGhIJkl	AbCdEfGHiJKl
AbcDdeFGhIJKl	AbcDefGhIJKl	ABcdEfgHiJKL	aBbCdEfgHiJKl	ABcDeFghIjKl
ABCdEfGhiJjKl	ABcDeFgHiJkL	aBcDeFGhIjKl	AbCdEfGgHIjKL	abCdeFGhIJkL
AbcDefGhIJKl	ABccDefGhIJkL	AbCdEfgHiJkL	ABcDeFghIjKkL	AbCDefGhIjKl
AbCDeFgHiJkL	aBcDeFGhIiJkL	aBcdEFgHIjKl	AbCdeFgHIJkL	aBcDeeFgHIjKL
aBcDefGhIjKL	AbCdEfghIJkL	AaBCdeFgHiJkL	aBCdEfGhIjKl	AbCdEFgHiJjKl

AbCdEfGHiJkL	aBcdEfGHiJKl	AbCdeFfGHiJKl	AbCdeFgHiJKL	aBcDefgHiJKL
aBCdDefgHiJKl	ABCdeFgHijKL	aBCdEfGhIjkLL	aBcDEfGhIjKl	AbcDEfGHiJkL
aBcdEfGHhIJkL	aBcdEfGhIJKl	AbCdefGhIJKl	ABcDeefGhIJkL	ABcDefgHiJKl
ABcDeFgHijKl	ABbCDeFgHijKl	ABcDeFGhIjKl	aBcDeFGhIJjKl	aBcDeFgHIJkL
aBcdEfgHIJkL	AbCdefFgHIjKL	AbCdefGhIjKL	AbCdEfgHiJkL	AbCDdEfGhiJkL
AbCDeFgHijKl	AbCDeFgHIjKll	AbCdEfGHiJKl	aBcDeFgHIjKL	aBcdeFgHHiJKL
aBcdeFgHiJKL	aBCdefGhIjKL	AbCdEefGhIjKL	aBCdEfGhiJkL	aBcDEfGhIjKl
AbCcDeFGhIjKl	AbcDeFGhIJkL	aBcdEfGhIJKl	AaBcdEfGhIJKl	AbCdeFghIJkL
ABcDefGhhIJkL	AbCDefGhiJkL	ABcDeFgHijKl	ABcDEeFgHiJkl	AbCDeFgHIjKl
AbcDeFGhIJkL	aBbcDeFgHIjKL	aBcdEfgHIjKL	AbCdeFghIiJKL	AbCdeFghIjKL

AbCdEfGhiJkL	AbCDeFgHhiJkL	aBCdEFgHiJkl	AbCdEFgHIjKl	AbcDdEfGHiJKl
AbcDefGHiJKL	aBcdEfgHiJKL	AaBcdEfgHiJKL	aBCdeFghIjKL	aBCdEfGhhIjKl
ABCdEfGhiJkL	aBCdEfGHiJkl	AbCdEeFGhIJkL	abCdEfGHiJKl	AbcDefGHiJKL
aBbcDefGhIJKl	ABcdEfgHiJKl	ABcDeFghIjJkL	ABcDeFghIjKl	ABcDEfGhiJkL
aBcDEfGgHiJkL	aBcDeFGhIjKl	AbCdeFGhIJkL	AbcDdeFgHIJkL	AbcDefGhIJkL
AbCdEfgHiJkL	AAbCdEfgHiJkL	AbCDeFghIjKl	AbCDeFgHiIjKl	AbCdEFgHiJkL
aBcDeFgHIjKl	AbCdeEfGHIjKl	AbCdeFgHIjKL	aBcDefGhIjKL	AbCcDefGhIjKL
aBCdEfgHijKL	aBCDeFghIjKkL	aBCdEfGhIjKl	AbCdEFgHiJkL	aBcdEFgGHiJkL
aBcdEfGHiJKl	AbCdeFgHiJKL	aBcDdeFghIJKL	aBcDefGhiJKl	ABCdEfgHijKLl
ABcDeFgHijKL	aBcDEfGhIjKl	aBCdEfGHiJjKl	AbcDeFGhIJkL	aBcdEfGhIJKl

AbCdeFfGhIJkL	AbCdeFghIJkL	ABcDefGhiJKl	ABbCDefGhiJkL	ABcDeFgHijKl
ABcDeFGhIjKkl	AbCDeFgHIjKl	AbcDeFgHIJkL	aBcdEfGgHIjKL	aBcdEfgHIjKL
AbCdeFghIjKL	ABcDdeFghIjKL	AbCdEfGhiJkL	AbCDeFgHijKlL	aBCdEFgHiJkl
AbCdEFgHIjKl	aBcDeFgHIiJKl	AbcDefGHiJKL	aBcdEfgHiJKL	AbCdeFfgHiJKL
aBcDeFghIjKL	aBCdEfGhiJkL	aBCcDEfGhiJkL	aBCdEfGhIjKl	AbCdEfGHiJKll
AbCdEfGhIJKl	AbcDefGhIJKl	ABcdEfgGhIJKl	ABcdEfgHiJKl	ABcDeFghIjKl
ABCdEeFghIjKl	ABcDeFgHiJkL	aBcDEfGhIjKl	AaBcDeFGhIjKl	AbCdeFGhIJkL
aBcDefGhIJJkL	AbcDefGhIJkL	AbCdEfgHiJkL	ABcDeFfgHiJkL	AbCDeFghIjKl
AbCDeFgHiJkL	aBbCdEFgHiJkL	aBcDeFgHIjKl	AbCdeFgHIJkKl	AbCdeFgHIjKL
aBcDefGhIjKL	AbCdEfggHiJKL	aBCdEfgHijKL	aBCDefGhIjkL	AbCDdEfGhIjKl

AbCdEfGHiJkL	aBcdEfGHIjKl	AaBcdEfGHiJKl	AbCdeFgHiJKL	aBcDefgHhIJKl
ABcDefgHiJKl	ABCdEfgHijKL	aBCdEfFgHijKl	ABcDEfGhIjKl	aBcDEfGHiJkL
abBcDeFGhIJkL	aBcdEfGhIJKl	AbCdefGhIJKkL	AbCdefGhIJkL	ABcDefgHiJkL
ABcDeFgHhiJkL	AbCDeFgHijKl	ABcDeFGhIjkL	aBcDdEFgHIjKl	aBcDeFgHIJkL
aBcdEfGhIJkL	AaBcdeFgHIjKL	AbCdefGhIjKL	ABcdEfgHhIjKL	AbCdEfGhiJkL
AbCDeFgHijKl	AbCDeFfGHijKl	AbCdEFgHiJKl	aBcDeFgHIjKL	abCcDefGHiJKL
aBcdeFgHiJKL	AbCdefGhIjKKL	aBcDefGhIjKL	aBCdEfgHiJkL	aBCdEFggHiJkL
aBcDEfGhIjKl	AbCdEfGHiJkL	aBcDdeFGhIJkL	aBcdEfGhIJKl	ABcdeFgHiJKL
aAbCdeFgHiJKl	ABcDefGhIjKl	ABCdEfgHiIjKl	ABcDeFgHiJkL	aBcDEfGhIjKl
AbCdEeFGhIjKl	AbCdeFGhIJkL	aBcdEfGhIJKl	AbCddEfGhIJkL	AbCdeFgHiJkL

ABcDefGhIjKl	ABbCDefGhIjKl	AbCDeFgHiJkL	aBcDeFGgHiJkL	aBcdEFgHIjKl
AbcDeFgHIJkL	aBcdEeFgHIjKL	aBcdEfgHIjKL	AbCdeFghIjKL	AbCCdeFghIjKL
aBCdEfGhIjkL	AbCDeFgHhIjKl	aBCdEfGHiJkL	abCdEfGHIjKl	AbcDeEfGHiJKl
AbCdefGHiJKL	aBcDefgHiJKL	aBCddEfgHiJKl	ABCdeFghIjKL	aBCdEfGhIjjKl
ABcDEfGhIjkL	aBcDEfGHiJkL	) )

when 'JapanEras'
Eras.new('Title' => 'JapanEras', 'List' => [
  { 'Nation'=>"{",   'Calendar'=>'JapanFMD0',
    'Name'  =>""    , 'Era'=>"()"     , 'Start'=>[ 593, [ 1,0],  1]},
  { 'Name'  =>""    , 'Era'=>"()"     , 'Start'=>[ 629, [ 1,0],  4]},
  { 'Name'  =>"c"    , 'Era'=>"(c)"     , 'Start'=>[ 642, [ 1,0], 15]},
  { 'Name'  =>"F"    , 'Era'=>"剻"       , 'Start'=>[ 645, [ 6,0], 19]},
  {                       'Era'=>""       , 'Start'=>[ 650, [ 2,0], 15]},
  { 'Name'  =>"Ė"    , 'Era'=>"(Ė)"     , 'Start'=>[ 655, [ 1,0],  3]},
  { 'Name'  =>"Vq"    , 'Era'=>"(Vq)"     , 'Start'=>[ 662, [ 1,0],  1]},
  { 'Name'  =>"O"    , 'Era'=>"(O)"     , 'Start'=>[ 672, [ 1,0],  1]},
  { 'Name'  =>"V"    , 'Era'=>"(V)"     , 'Start'=>[ 673, [ 2,0], 27]},
  {                       'Era'=>"钹"       , 'Start'=>[ 686, [ 7,0], 20]},
  { 'Name'  =>""    , 'Era'=>"()"     , 'Start'=>[ 687, [ 1,0],  1]},
  { 'Name'  =>""    , 'Era'=>"()"     , 'Start'=>[ 697, [ 8,0],  1]},
  {                       'Era'=>""       , 'Start'=>[ 701, [ 3,0], 21]},
  {                       'Era'=>"c_"       , 'Start'=>[ 704, [ 5,0], 10]},
  { 'Name'  =>""    , 'Era'=>"a"       , 'Start'=>[ 708, [ 1,0], 11]},
  { 'Name'  =>""    , 'Era'=>"T"       , 'Start'=>[ 715, [ 9,0],  2]},
  {                       'Era'=>"{V"       , 'Start'=>[ 717, [11,0], 17]},
  { 'Name'  =>""    , 'Era'=>"_T"       , 'Start'=>[ 724, [ 2,0],  4]},
  {                       'Era'=>"V"       , 'Start'=>[ 729, [ 8,0],  5]},
  {                       'Era'=>"V"   , 'Start'=>[ 749, [ 4,0], 14]},
  { 'Name'  =>"F"    , 'Era'=>"V"   , 'Start'=>[ 749, [ 7,0],  2]},
  {                       'Era'=>"V"   , 'Start'=>[ 757, [ 8,0], 18]},
  { 'Name'  =>"~m"    , 'Era'=>"V  2", 'Start'=>[ 758, [ 8,0],  1]},
  { 'Name'  =>"̓"    , 'Era'=>"V_"   , 'Start'=>[ 765, [ 1,0],  7]},
  {                       'Era'=>"_i_"   , 'Start'=>[ 767, [ 8,0], 16]},
  { 'Name'  =>"m"    , 'Era'=>"T"       , 'Start'=>[ 770, [10,0],  1]},
  {                       'Era'=>"V"       , 'Start'=>[ 781, [ 1,0],  1]},
  { 'Name'  =>""    , 'Era'=>""       , 'Start'=>[ 782, [ 8,0], 19]},
  { 'Name'  =>""    , 'Era'=>"哯"       , 'Start'=>[ 806, [ 5,0], 18]},
  { 'Name'  =>""    , 'Era'=>"Om"       , 'Start'=>[ 810, [ 9,0], 19]},
  { 'Name'  =>"~a"    , 'Era'=>"V"       , 'Start'=>[ 824, [ 1,0],  5]},
  { 'Name'  =>"m"    , 'Era'=>"a"       , 'Start'=>[ 834, [ 1,0],  3]},
  {                       'Era'=>"Ï"       , 'Start'=>[ 848, [ 6,0], 13]},
  { 'Name'  =>""    , 'Era'=>"m"       , 'Start'=>[ 851, [ 4,0], 28]},
  {                       'Era'=>"čt"       , 'Start'=>[ 854, [11,0], 30]},
  {                       'Era'=>"V"       , 'Start'=>[ 857, [ 2,0], 21]},
  { 'Name'  =>"a"    , 'Era'=>""       , 'Start'=>[ 859, [ 4,0], 15]},
  { 'Name'  =>"z"    , 'Era'=>"c"       , 'Start'=>[ 877, [ 4,0], 16]},
  { 'Name'  =>"F"    , 'Era'=>"ma"       , 'Start'=>[ 885, [ 2,0], 21]},
  { 'Name'  =>"F"    , 'Era'=>""       , 'Start'=>[ 889, [ 4,0], 27]},
  { 'Name'  =>""    , 'Era'=>""       , 'Start'=>[ 898, [ 4,0], 26]},
  {                       'Era'=>""       , 'Start'=>[ 901, [ 7,0], 15]},
  {                       'Era'=>""       , 'Start'=>[ 923, [ 4,2], 11]},
  { 'Name'  =>"鐝"    , 'Era'=>""       , 'Start'=>[ 931, [ 4,0], 26]},
  {                       'Era'=>"Vc"       , 'Start'=>[ 938, [ 5,0], 22]},
  { 'Name'  =>""    , 'Era'=>"V"       , 'Start'=>[ 947, [ 4,0], 22]},
  {                       'Era'=>"V"       , 'Start'=>[ 957, [10,0], 27]},
  {                       'Era'=>"a"       , 'Start'=>[ 961, [ 2,0], 16]},
  {                       'Era'=>"N"       , 'Start'=>[ 964, [ 7,0], 10]},
  { 'Name'  =>""    , 'Era'=>"a"       , 'Start'=>[ 968, [ 8,0], 13]},
  { 'Name'  =>"~Z"    , 'Era'=>"V\"       , 'Start'=>[ 970, [ 3,0], 25]},
  {                       'Era'=>"V"       , 'Start'=>[ 973, [12,0], 20]},
  {                       'Era'=>"匳"       , 'Start'=>[ 976, [ 7,0], 13]},
  {                       'Era'=>"V"       , 'Start'=>[ 978, [11,0], 29]},
  {                       'Era'=>"i"       , 'Start'=>[ 983, [ 4,0], 15]},
  { 'Name'  =>"ԎR"    , 'Era'=>"a"       , 'Start'=>[ 985, [ 4,0], 27]},
  { 'Name'  =>""    , 'Era'=>"i"       , 'Start'=>[ 987, [ 4,0],  5]},
  {                       'Era'=>"iN"       , 'Start'=>[ 989, [ 8,0],  8]},
  {                       'Era'=>""       , 'Start'=>[ 990, [11,0],  7]},
  {                       'Era'=>""       , 'Start'=>[ 995, [ 2,0], 22]},
  {                       'Era'=>""       , 'Start'=>[ 999, [ 1,0], 13]},
  {                       'Era'=>"O"       , 'Start'=>[1004, [ 7,0], 20]},
  { 'Name'  =>"O"    , 'Era'=>"a"       , 'Start'=>[1012, [12,0], 25]},
  { 'Name'  =>""  , 'Era'=>"m"       , 'Start'=>[1017, [ 4,0], 23]},
  {                       'Era'=>""       , 'Start'=>[1021, [ 2,0],  2]},
  {                       'Era'=>""       , 'Start'=>[1024, [ 7,0], 13]},
  {                       'Era'=>""       , 'Start'=>[1028, [ 7,0], 25]},
  { 'Name'  =>"鐝"  , 'Era'=>""       , 'Start'=>[1037, [ 4,0], 21]},
  {                       'Era'=>"v"       , 'Start'=>[1040, [11,0], 10]},
  {                       'Era'=>""       , 'Start'=>[1044, [11,0], 24]},
  { 'Name'  =>""  , 'Era'=>"i"       , 'Start'=>[1046, [ 4,0], 14]},
  {                       'Era'=>"V"       , 'Start'=>[1053, [ 1,0], 11]},
  {                       'Era'=>"N"       , 'Start'=>[1058, [ 8,0], 29]},
  {                       'Era'=>""       , 'Start'=>[1065, [ 8,0],  2]},
  { 'Name'  =>"O"  , 'Era'=>"v"       , 'Start'=>[1069, [ 4,0], 13]},
  { 'Name'  =>""    , 'Era'=>""       , 'Start'=>[1074, [ 8,0], 23]},
  {                       'Era'=>""       , 'Start'=>[1077, [11,0], 17]},
  {                       'Era'=>"i"       , 'Start'=>[1081, [ 2,0], 10]},
  {                       'Era'=>""       , 'Start'=>[1084, [ 2,0],  7]},
  { 'Name'  =>"x"    , 'Era'=>""       , 'Start'=>[1087, [ 4,0],  7]},
  {                       'Era'=>"Õ"       , 'Start'=>[1094, [12,0], 15]},
  {                       'Era'=>"i"       , 'Start'=>[1096, [12,0], 17]},
  {                       'Era'=>""       , 'Start'=>[1097, [11,0], 21]},
  {                       'Era'=>"Na"       , 'Start'=>[1099, [ 8,0], 28]},
  {                       'Era'=>""       , 'Start'=>[1104, [ 2,0], 10]},
  {                       'Era'=>"Ï"       , 'Start'=>[1106, [ 4,0],  9]},
  { 'Name'  =>"H"    , 'Era'=>"Vm"       , 'Start'=>[1108, [ 8,0],  3]},
  {                       'Era'=>"Vi"       , 'Start'=>[1110, [ 7,0], 13]},
  {                       'Era'=>"iv"       , 'Start'=>[1113, [ 7,0], 13]},
  {                       'Era'=>"i"       , 'Start'=>[1118, [ 4,0],  3]},
  {                       'Era'=>"ۈ"       , 'Start'=>[1120, [ 4,0], 10]},
  { 'Name'  =>""    , 'Era'=>"V"       , 'Start'=>[1124, [ 4,0],  3]},
  {                       'Era'=>"厡"       , 'Start'=>[1126, [ 1,0], 22]},
  {                       'Era'=>"V"       , 'Start'=>[1131, [ 1,0], 29]},
  {                       'Era'=>""       , 'Start'=>[1132, [ 8,0], 11]},
  {                       'Era'=>"ۉ"       , 'Start'=>[1135, [ 4,0], 27]},
  {                       'Era'=>"i"       , 'Start'=>[1141, [ 7,0], 10]},
  { 'Name'  =>"߉q"    , 'Era'=>"N"       , 'Start'=>[1142, [ 4,0], 28]},
  {                       'Era'=>"V{"       , 'Start'=>[1144, [ 2,0], 23]},
  {                       'Era'=>"v"       , 'Start'=>[1145, [ 7,0], 22]},
  {                       'Era'=>"m"       , 'Start'=>[1151, [ 1,0], 26]},
  {                       'Era'=>"v"       , 'Start'=>[1154, [10,0], 28]},
  { 'Name'  =>"㔒"  , 'Era'=>"ی"       , 'Start'=>[1156, [ 4,0], 27]},
  { 'Name'  =>""    , 'Era'=>""       , 'Start'=>[1159, [ 4,0], 20]},
  {                       'Era'=>"i"       , 'Start'=>[1160, [ 1,0], 10]},
  {                       'Era'=>""       , 'Start'=>[1161, [ 9,0],  4]},
  {                       'Era'=>""       , 'Start'=>[1163, [ 3,0], 29]},
  {                       'Era'=>"i"       , 'Start'=>[1165, [ 6,0],  5]},
  { 'Name'  =>"Z"    , 'Era'=>"m"       , 'Start'=>[1166, [ 8,0], 27]},
  { 'Name'  =>"q"    , 'Era'=>"É"       , 'Start'=>[1169, [ 4,0],  8]},
  {                       'Era'=>""       , 'Start'=>[1171, [ 4,0], 21]},
  {                       'Era'=>""       , 'Start'=>[1175, [ 7,0], 28]},
  {                       'Era'=>""       , 'Start'=>[1177, [ 8,0],  4]},
  { 'Name'  =>""    , 'Era'=>"{a"       , 'Start'=>[1181, [ 7,0], 14]},
  {                       'Era'=>"i"       , 'Start'=>[1182, [ 5,0], 27]},
  { 'Nation'=>""  , 'Era'=>"i  2"    , 'Start'=>[1183, [ 8,0], 20]},
  { 'Nation'=>""  , 
    'Name'  =>"㒹H"  , 'Era'=>""       , 'Start'=>[1184, [ 4,0], 16]},
  { 'Nation'=>"{",     'Era'=>"  2"    , 'Start'=>[1185, [ 3,0], 25]},
  {                       'Era'=>""       , 'Start'=>[1185, [ 8,0], 14]},
  {                       'Era'=>"v"       , 'Start'=>[1190, [ 4,0], 11]},
  { 'Name'  =>"y"  , 'Era'=>""       , 'Start'=>[1199, [ 4,0], 27]},
  {                       'Era'=>"m"       , 'Start'=>[1201, [ 2,0], 13]},
  {                       'Era'=>"v"       , 'Start'=>[1204, [ 2,0], 20]},
  {                       'Era'=>"i"       , 'Start'=>[1206, [ 4,0], 27]},
  {                       'Era'=>""       , 'Start'=>[1207, [10,0], 25]},
  { 'Name'  =>""    , 'Era'=>""       , 'Start'=>[1211, [ 3,0],  9]},
  {                       'Era'=>""       , 'Start'=>[1213, [12,0],  6]},
  {                       'Era'=>"v"       , 'Start'=>[1219, [ 4,0], 12]},
  { 'Name'  =>""    , 'Era'=>"v  3"    , 'Start'=>[1221, [ 4,0], 20]},
  { 'Name'  =>"x"  , 'Era'=>"剞"       , 'Start'=>[1222, [ 4,0], 13]},
  {                       'Era'=>"m"       , 'Start'=>[1224, [11,0], 20]},
  {                       'Era'=>"Ø\"       , 'Start'=>[1225, [ 4,0], 20]},
  {                       'Era'=>""       , 'Start'=>[1227, [12,0], 10]},
  {                       'Era'=>""       , 'Start'=>[1229, [ 3,0],  5]},
  {                       'Era'=>"i"       , 'Start'=>[1232, [ 4,0],  2]},
  { 'Name'  =>"l"    , 'Era'=>"V"       , 'Start'=>[1233, [ 4,0], 15]},
  {                       'Era'=>""       , 'Start'=>[1234, [11,0],  5]},
  {                       'Era'=>"Ò"       , 'Start'=>[1235, [ 9,0], 19]},
  {                       'Era'=>"m"       , 'Start'=>[1238, [11,0], 23]},
  {                       'Era'=>""       , 'Start'=>[1239, [ 2,0],  7]},
  {                       'Era'=>"m"       , 'Start'=>[1240, [ 7,0], 16]},
  { 'Name'  =>"㍵"  , 'Era'=>""       , 'Start'=>[1243, [ 2,0], 26]},
  { 'Name'  =>"["  , 'Era'=>""       , 'Start'=>[1247, [ 2,0], 28]},
  {                       'Era'=>""       , 'Start'=>[1249, [ 3,0], 18]},
  {                       'Era'=>"N"       , 'Start'=>[1256, [10,0],  5]},
  {                       'Era'=>""       , 'Start'=>[1257, [ 3,0], 14]},
  {                       'Era'=>""       , 'Start'=>[1259, [ 3,0], 26]},
  { 'Name'  =>"TR"    , 'Era'=>""       , 'Start'=>[1260, [ 4,0], 13]},
  {                       'Era'=>"O"       , 'Start'=>[1261, [ 2,0], 20]},
  {                       'Era'=>"i"       , 'Start'=>[1264, [ 2,0], 28]},
  { 'Name'  =>"F"  , 'Era'=>""       , 'Start'=>[1275, [ 4,0], 25]},
  {                       'Era'=>"O"       , 'Start'=>[1278, [ 2,0], 29]},
  { 'Name'  =>""    , 'Era'=>""       , 'Start'=>[1288, [ 4,0], 28]},
  {                       'Era'=>"im"       , 'Start'=>[1293, [ 8,0],  5]},
  { 'Name'  =>"㕚"  , 'Era'=>""       , 'Start'=>[1299, [ 4,0], 25]},
  { 'Name'  =>""  , 'Era'=>""       , 'Start'=>[1302, [11,0], 21]},
  {                       'Era'=>"Ì"       , 'Start'=>[1303, [ 8,0],  5]},
  {                       'Era'=>""       , 'Start'=>[1306, [12,0], 14]},
  { 'Name'  =>"ԉ"    , 'Era'=>"c"       , 'Start'=>[1308, [10,0],  9]},
  {                       'Era'=>""       , 'Start'=>[1311, [ 4,0], 28]},
  {                       'Era'=>"a"       , 'Start'=>[1312, [ 3,0], 20]},
  {                       'Era'=>""       , 'Start'=>[1317, [ 2,0],  3]},
  { 'Name'  =>""  , 'Era'=>""       , 'Start'=>[1319, [ 4,0], 28]},
  {                       'Era'=>""       , 'Start'=>[1321, [ 2,0], 23]},
  {                       'Era'=>""       , 'Start'=>[1324, [12,0],  9]},
  {                       'Era'=>"×"       , 'Start'=>[1326, [ 4,0], 26]},
  {                       'Era'=>""       , 'Start'=>[1329, [ 8,0], 29] ,
                                                'End'  =>[1331, [ 8,0],  9]},
  {                       'Era'=>"O  3"    , 'Start'=>[1333, [ 5,0], 18]},
  {                       'Era'=>""       , 'Start'=>[1334, [ 1,0], 29] ,
                                                'End'  =>[1336, [ 2,0], 29]},
  { 'Name'  =>"㏬"  , 'Era'=>"  3"    , 'Start'=>[1392, [10,2],  6]},
  {                       'Era'=>"i"       , 'Start'=>[1394, [ 7,0],  5]},
  { 'Name'  =>"̌"    , 'Era'=>"i 19"    , 'Start'=>[1412, [ 8,0], 29]},
  {                       'Era'=>""       , 'Start'=>[1428, [ 4,0], 27]},
  { 'Name'  =>"ԉ"  , 'Era'=>"i"       , 'Start'=>[1429, [ 9,0],  5]},
  {                       'Era'=>"Ëg"       , 'Start'=>[1441, [ 2,0], 17]},
  {                       'Era'=>""       , 'Start'=>[1444, [ 2,0],  5]},
  {                       'Era'=>""       , 'Start'=>[1449, [ 7,0], 28]},
  {                       'Era'=>""       , 'Start'=>[1452, [ 7,0], 25]},
  {                       'Era'=>"N"       , 'Start'=>[1455, [ 7,0], 25]},
  {                       'Era'=>"\"       , 'Start'=>[1457, [ 9,0], 28]},
  {                       'Era'=>""       , 'Start'=>[1460, [12,0], 21]},
  { 'Name'  =>"y", 'Era'=>""       , 'Start'=>[1466, [ 2,0], 28]},
  {                       'Era'=>"m"       , 'Start'=>[1467, [ 3,0],  5]},
  {                       'Era'=>""       , 'Start'=>[1469, [ 4,0], 28]},
  {                       'Era'=>""       , 'Start'=>[1487, [ 7,0], 20]},
  {                       'Era'=>""       , 'Start'=>[1489, [ 8,0], 21]},
  {                       'Era'=>""       , 'Start'=>[1492, [ 7,0], 19]},
  { 'Name'  =>"㔐"  , 'Era'=>"T"       , 'Start'=>[1501, [ 2,0], 29]},
  {                       'Era'=>"i"       , 'Start'=>[1504, [ 2,0], 30]},
  {                       'Era'=>"i"       , 'Start'=>[1521, [ 8,0], 23]},
  { 'Name'  =>"ޗ"  , 'Era'=>"\"       , 'Start'=>[1528, [ 8,0], 20]},
  {                       'Era'=>"V"       , 'Start'=>[1532, [ 7,0], 29]},
  {                       'Era'=>"O"       , 'Start'=>[1555, [10,0], 23]},
  { 'Name'  =>"e"  , 'Era'=>"i\"       , 'Start'=>[1558, [ 2,0], 28]},
  {                       'Era'=>"T"       , 'Start'=>[1570, [ 4,0], 23]},
  {                       'Era'=>"V"       , 'Start'=>[1573, [ 7,0], 28]},
  { 'Name'  =>"z"  , 'Era'=>"V 14"    , 'Start'=>[1586, [11,0],  7]},
  {                       'Era'=>"\"       , 'Start'=>[1592, [12,0],  8]},
  {                       'Era'=>"c"       , 'Start'=>[1596, [10,0], 27]},
  { 'Name'  =>"㐅"  , 'Era'=>"c 16"    , 'Start'=>[1611, [ 3,0], 27]},
  {                       'Era'=>"a"       , 'Start'=>[1615, [ 7,0], 13]},
  {                       'Era'=>"i"       , 'Start'=>[1624, [ 2,0], 30]},
  { 'Name'  =>""    , 'Era'=>"i  6"    , 'Start'=>[1629, [11,0],  8]},
  { 'Name'  =>""  , 'Era'=>""       , 'Start'=>[1644, [12,0], 16]},
  {                       'Era'=>"c"       , 'Start'=>[1648, [ 2,0], 15]},
  {                       'Era'=>""       , 'Start'=>[1652, [ 9,0], 18]},
  { 'Name'  =>"㐼"    , 'Era'=>""       , 'Start'=>[1655, [ 4,0], 13]},
  {                       'Era'=>""       , 'Start'=>[1658, [ 7,0], 23]},
  {                       'Era'=>""       , 'Start'=>[1661, [ 4,0], 25]},
  { 'Name'  =>"쌳"    , 'Era'=>"  3"    , 'Start'=>[1663, [ 1,0], 26]},
  {                       'Era'=>""       , 'Start'=>[1673, [ 9,0], 21]},
  {                       'Era'=>"Va"       , 'Start'=>[1681, [ 9,0], 29]},
  {                       'Era'=>"勝"       , 'Start'=>[1684, [ 2,0], 21]},
  { 'Name'  =>"R"    , 'Era'=>"\"       , 'Start'=>[1688, [ 9,0], 30]},
  {                       'Era'=>"i"       , 'Start'=>[1704, [ 3,0], 13]},
  { 'Name'  =>""  , 'Era'=>""       , 'Start'=>[1711, [ 4,0], 25]},
  {                       'Era'=>""       , 'Start'=>[1716, [ 6,0], 22]},
  { 'Name'  =>""    , 'Era'=>""       , 'Start'=>[1736, [ 4,0], 28]},
  {                       'Era'=>""       , 'Start'=>[1741, [ 2,0], 27]},
  {                       'Era'=>""       , 'Start'=>[1744, [ 2,0], 21]},
  { 'Name'  =>""    , 'Era'=>""       , 'Start'=>[1748, [ 7,0], 12]},
  {                       'Era'=>""       , 'Start'=>[1751, [10,0], 27]},
  { 'Name'  =>""  , 'Era'=>"a"       , 'Start'=>[1764, [ 6,0],  2]},
  { 'Name'  =>"㓍"  , 'Era'=>"i"       , 'Start'=>[1772, [11,0], 16]},
  { 'Name'  =>"i"    , 'Era'=>"V"       , 'Start'=>[1781, [ 4,0],  2]},
  {                       'Era'=>""       , 'Start'=>[1789, [ 1,0], 25]},
  {                       'Era'=>"a"       , 'Start'=>[1801, [ 2,0],  5]},
  {                       'Era'=>""       , 'Start'=>[1804, [ 2,0], 11]},
  { 'Name'  =>"mF"    , 'Era'=>""       , 'Start'=>[1818, [ 4,0], 22]},
  {                       'Era'=>"V"       , 'Start'=>[1830, [12,0], 10]},
  {                       'Era'=>"O"       , 'Start'=>[1844, [12,0],  2]},
  { 'Name'  =>"F"    , 'Era'=>"Éi"       , 'Start'=>[1848, [ 2,0], 28]},
  {                       'Era'=>""       , 'Start'=>[1854, [11,0], 27]},
  {                       'Era'=>""       , 'Start'=>[1860, [ 3,0], 18]},
  {                       'Era'=>"v"       , 'Start'=>[1861, [ 2,0], 19]},
  {                       'Era'=>""       , 'Start'=>[1864, [ 2,0], 20]},
  {                       'Era'=>"c"       , 'Start'=>[1865, [ 4,0],  8]},
  { 'Name'  =>""    , 'Era'=>""       , 'Start'=>[1868, [ 9,0],  8]},
  {                     'Calendar' => 'Gregorian',
                          'Era'=>" 6"     , 'Start'=>[1873,      1,  1]},
  { 'Name'  =>"吳"    , 'Era'=>"吳"       , 'Start'=>[1912,      7, 30]},
  { 'Name'  =>"a"    , 'Era'=>"a"       , 'Start'=>[1926,     12, 25]},
  { 'Name'  =>""    , 'Era'=>""       , 'Start'=>[1989,      1,  8] ,
                                                'End'  =>[2088,      1,  1]},
  { 'Nation'=>"o",'Calendar' => 'JapanFMD0',
    'Name'  =>""  , 'Era'=>"O"       , 'Start'=>[1331, [ 8,0],  9] ,
                                                'End'  =>[1333, [ 5,0], 18]},
  { 'Nation'=>"쒩"    , 'Era'=>""       , 'Start'=>[1336, [ 2,0], 29]},
  { 'Name'  =>"㑺"  , 'Era'=>""       , 'Start'=>[1340, [ 4,0], 28]},
  {                       'Era'=>""       , 'Start'=>[1346, [12,0],  8]},
  { 'Nation'=>"{",     'Era'=>"  6"    , 'Start'=>[1351, [11,0],  8]},
  { 'Nation'=>"쒩"    , 'Era'=>"  7"    , 'Start'=>[1352, [ 8,0], 17]},
  { 'Name'  =>"c"    , 'Era'=>""       , 'Start'=>[1370, [ 7,0], 24]},
  {                       'Era'=>""       , 'Start'=>[1372, [ 4,0],  1]},
  {                       'Era'=>"V"       , 'Start'=>[1375, [ 5,0], 27]},
  {                       'Era'=>"Oa"       , 'Start'=>[1381, [ 2,0], 10]},
  { 'Name'  =>"TR"  , 'Era'=>""       , 'Start'=>[1384, [ 4,0], 28] ,
                                                'End'  =>[1392, [10,2],  6]},
  { 'Nation'=>"@", 
    'Name'  =>""        , 'Era'=>"  3"    , 'Start'=>[1331, [ 8,0],  9]},
  { 'Name'  =>""    , 'Era'=>"  3"    , 'Start'=>[1331, [ 9,0], 20]},
  {                       'Era'=>"c"       , 'Start'=>[1332, [ 4,0], 28] ,
                                                'End'  =>[1333, [ 5,0], 18]},
  { 'Nation'=>"k"    , 
    'Name'  =>""        , 'Era'=>"  2"    , 'Start'=>[1336, [ 2,0], 29]},
  { 'Name'  =>""    , 'Era'=>"  3"    , 'Start'=>[1336, [ 8,0], 15]},
  {                       'Era'=>""       , 'Start'=>[1338, [ 8,0], 28]},
  {                       'Era'=>"Ni"       , 'Start'=>[1342, [ 4,0], 27]},
  {                       'Era'=>"a"       , 'Start'=>[1345, [10,0], 21]},
  { 'Name'  =>""    , 'Era'=>"ω"       , 'Start'=>[1350, [ 2,0], 27] ,
                                                'End'  =>[1351, [11,0],  8]},
  { 'Name'  =>""  , 'Era'=>"ω  3"    , 'Start'=>[1352, [ 8,0], 17]},
  {                       'Era'=>"a"       , 'Start'=>[1352, [ 9,0], 27]},
  {                       'Era'=>""       , 'Start'=>[1356, [ 3,0], 28]},
  {                       'Era'=>"N"       , 'Start'=>[1361, [ 3,0], 29]},
  {                       'Era'=>"厡"       , 'Start'=>[1362, [ 9,0], 23]},
  {                       'Era'=>""       , 'Start'=>[1368, [ 2,0], 18]},
  { 'Name'  =>"~Z"  , 'Era'=>"  4"    , 'Start'=>[1371, [ 3,0], 23]},
  {                       'Era'=>"ia"       , 'Start'=>[1375, [ 2,0], 27]},
  {                       'Era'=>"N"       , 'Start'=>[1379, [ 3,0], 22]},
  {                       'Era'=>"i"       , 'Start'=>[1381, [ 2,0], 24]},
  { 'Name'  =>"㏬"  , 'Era'=>""       , 'Start'=>[1384, [ 2,0], 27]},
  {                       'Era'=>"Ìc"       , 'Start'=>[1387, [ 8,0], 23]},
  {                       'Era'=>"N"       , 'Start'=>[1389, [ 2,0],  9]},
  {                       'Era'=>""       , 'Start'=>[1390, [ 3,0], 26] ,
                                                'End'  =>[1392, [10,2],  6]},
  { 'Nation'=>""  , 
    'Name'  =>"q"    , 'Era'=>"  5"    , 'Start'=>[1181, [ 7,0], 14]},
  { 'Nation'=>""  , 
    'Name'  =>""    , 'Era'=>"i  3"    , 'Start'=>[1184, [ 4,0], 16] ,
                                                'Death'=>[1185, [ 3,0], 25]}
])
end
end
end
