# timezone.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  TTTTT I M     M EEEEE ZZZZZ  OOO  N   N EEEEE
#    T   I MM   MM E        Z  O   O NN  N E    
#    T   I M M M M EEEE    Z   O   O N N N EEEE 
#    T   I M  M  M E      Z    O   O N  NN E    
#    T   I M     M EEEEE ZZZZZ  OOO  N   N EEEEE
#
=begin #########################################################
#=Timezone                                                     #
\===NX(̎n̊Ԃ̕ϊ)                     #
#                                                              #
\==X[p[NX:                                             #
$==Super Class:                                                #
#*Outfit+                                                      #
=end ###########################################################

class Timezone < Outfit

=begin #########################################################
\==NX萔 & ϐ                                           #
$==Class Constant & Variable:                                  #
=end ###########################################################

=begin ***********
\ UTC_EPOCH # 1970-01-01T12:00:00Z ̃EXʓ
\ ZONES     # ^C][̒`
=end =============

  UTC_EPOCH = 2440587

  ZONES = {
    'ut'  =>  0*3600, 'gmt' =>  0*3600,
    'est' => -5*3600, 'edt' => -4*3600, 'et'=>[-5*3600,[4,1,0],[10,-1,0],2,1],
    'cst' => -6*3600, 'cdt' => -5*3600, 'ct'=>[-6*3600,[4,1,0],[10,-1,0],2,1],
    'mst' => -7*3600, 'mdt' => -6*3600, 'mt'=>[-7*3600,[4,1,0],[10,-1,0],2,1],
    'pst' => -8*3600, 'pdt' => -7*3600, 'pt'=>[-8*3600,[4,1,0],[10,-1,0],2,1],
    'a'   =>  1*3600, 'b'   =>  2*3600, 'c'   =>  3*3600, 'd'   =>  4*3600,
    'e'   =>  5*3600, 'f'   =>  6*3600, 'g'   =>  7*3600, 'h'   =>  8*3600,
    'i'   =>  9*3600, 'k'   => 10*3600, 'l'   => 11*3600, 'm'   => 12*3600,
    'n'   => -1*3600, 'o'   => -2*3600, 'p'   => -3*3600, 'q'   => -4*3600,
    'r'   => -5*3600, 's'   => -6*3600, 't'   => -7*3600, 'u'   => -8*3600,
    'v'   => -9*3600, 'w'   =>-10*3600, 'x'   =>-11*3600, 'y'   =>-12*3600,
    'z'   =>  0*3600,
    'utc' =>  0*3600, 'wet' =>  0*3600, 'bst' =>  1*3600, 'wat' => -1*3600,
    'at'  => -2*3600, 'ast' => -4*3600, 'adt' => -3*3600, 'yst' => -9*3600,
    'ydt' => -8*3600, 'hst' =>-10*3600, 'hdt' => -9*3600, 'cat' =>-10*3600,
    'ahst'=>-10*3600, 'nt'  =>-11*3600, 'idlw'=>-12*3600, 'cet' =>  1*3600,
    'met' =>  1*3600, 'mewt'=>  1*3600, 'mest'=>  2*3600, 'mesz'=>  2*3600,
    'swt' =>  1*3600, 'sst' =>  2*3600, 'fwt' =>  1*3600, 'fst' =>  2*3600,
    'eet' =>  2*3600, 'bt'  =>  3*3600, 'zp4' =>  4*3600, 'zp5' =>  5*3600,
    'zp6' =>  6*3600, 'wast'=>  7*3600, 'wadt'=>  8*3600, 'cct' =>  8*3600,
    'jst' =>  9*3600, 'east'=> 10*3600, 'eadt'=> 11*3600, 'gst' => 10*3600,
    'nzt' => 12*3600, 'nzst'=> 12*3600, 'nzdt'=> 13*3600, 'idle'=> 12*3600
  }
  @@outfit = {
    'Objs' => [],
    'Hash' => {},
    'Keys' => [
      ['([+-])(\\d{2}):?(\\d{2})?' , proc{ |m| 
          zone  = Rational(m[2].to_i * 60 + m[3].to_i, 1440)
          zone *= -1 if m[1] == '-'
          Timezone.new(zone, m[0])
        }
      ]
    ]
  }
  @@outfit['Key0'] = @@outfit['Keys'].dup

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- Timezone.get(key [, n=1])
\  L[Agp Timezone+IuWFNgIĕԂ܂B
\
\    key  (Timezone+)L[
\    n    n ԖڂɃ}b` Timezone+IuWFNgI悤Ɏw
=end =============
    def get(key, n=1)
      case key
      when Timezone
        return key if (n -= 1) == 0
      when String
        @@outfit['Objs'].each do |item|
          item._title.each do |title|
            match = title.sub(/^([-+])/, '[\1]')
            return item if key =~ /^#{match}$/i && (n -= 1) == 0
          end
        end
        ZONES.each do |title, v|
          if title == key.downcase
            if Numeric === v
              return Timezone.new(Rational(v,     86400), 'Title'=>title)
            else
              return DST.new     (Rational(v[0],  86400), 'Title'=>title, 
                'Start'=>v[1], 'End'=>v[2], 'Midnight'=>v[3], 'Diff'=>v[4])
            end
          end
          if key =~ /^#{title}\s+dst$/
            retuen Timezone.new(Rational(v+3600,86400), 'Title'=>key)
          end
        end
        @@outfit['Keys'].each do |item|
          [*item[0]].each do |title|
            match = title.sub(/^([-+])/, '[\1]')
            return item[1].call($~.dup) if key =~ /^#{match}$/i  && (n-=1) == 0
          end
        end
      end
      return nil
    end

=begin ***********
#--- Timezone.zone([time=Time.now])
\  vZ@ɐݒ肳Ă鎞(P , o)ɊÂ
\  Timezone+IuWFNg𐶐ĕԂ܂B
\
\    time w肷 Time*IuWFNg
=end =============
    def zone(time=Time.now)
      zone = Time.gm(*time.to_a).to_i - time.to_i
      zone += zone / zone.abs unless zone == 0
      self.new((zone / 60).to_r/1440)
    end

=begin ***********
#--- Timezone.deltaT(jd)
\  T = TDT - UTC Ԃ܂B
\  (͏ 0 Ԃ܂)
\
\    jd  EXʓ
=end =============
# Not supported
    def deltaT(jd)
      0
    end
  end # of class method

=begin ***********
#--- Timezone.new(zone=0 [, *quality])
\  Timezone+IuWFNg𐶐ĕԂ܂B
\
\    zone     (P , o)
\    quality  `nbV
=end =============
  def initialize(zone=0, *quality)
    @zone = zone || Timezone.zone.zone
    if Array === quality
      if Hash === quality[0]
        quality = quality[0]
      elsif quality.length > 0
        quality = {'Title'=>[*quality]}
      else
        quality = {'Title'=>to_s}
      end
    end
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==pubN CX^X \bh:                           #
$==Public Instance Method:                                     #
=end ###########################################################
  public

=begin ***********
#--- Timezone#zone([sd=nil])
\  Ԃ܂B
\
\  sd  vZ
=end =============
  def zone(sd=nil) @zone end

=begin ***********
#--- Timezone#to_s_with_dst([rjd=nil])
#--- Timezone#to_s  (not daylight saving time)
\  𕶎`ŕԂ܂B
\
\  sd  vZ
=end =============
  def to_s_with_dst(rjd=nil)
    z = zone(rjd)
    ['Z',
      format('%+.2d%02d',
	     (z     / (1.to_r/24)).to_i,
	     (z.abs % (1.to_r/24) / (1.to_r/1440)).to_i)
    ][z<=>0]
  end
  def to_s() to_s_with_dst() end

=begin ***********
#--- Timezone#jd_to_sd(jd)
\  EXʓnʓɕϊĕԂ܂B
\
\    jd  EXʓ
=end =============
  def jd_to_sd(jd) jd + @zone end

=begin ***********
#--- Timezone#sd_to_jd(sd)
\  nʓEXʓɕϊĕԂ܂B
\
\    sd  nʓ
=end =============
  def sd_to_jd(sd) sd - @zone end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Timezone#_qualify
\  Timezone+IuWFNg̐`ݒ肵܂B
\
\  @Title      = Timezone.get ̃L[ƂȂ鎞
=end =============
  def _qualify
    if @Title
      @Title = [*@Title]
      @@outfit['Objs'].push(self)
    end
  end
end
